#include <hmg.ch>

function fueltxn
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   private aTransactions := {}   
   private nCurrentID := 0
   private lModifyMode := .f.
   private cSort := 'Tag'
   private nCount := 0
   define window txn at 0, 0 width 700 height 500 icon 'icon' title 'Fuel Transaction Entry' modal nosize 
      define toolbar toolbar1 imagewidth 24 imageheight 24 flat .t. strictwidth .t.
         button newveh   picture 'car'  action newtxnveh() tooltip 'Vehicles Master' 
         button reset   picture 'reset'  action resettxn() tooltip 'Reset Transaction Entry/Modification' 
         button delete   picture 'delete1' action deletetxn() tooltip 'Delete the Current Transaction in the Transaction List'
         button tagmanager   picture 'tag' action ( TagManager(), txnchanged() ) tooltip 'Tag Manager' separator
         button exit  picture 'exit' action txn.release() tooltip 'Exit'
      end toolbar   
      define textbox date
         row 40
         col 10
         width 100
         date .t.
         value date()    
//         ongotfocus HMGClearSel()         
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end textbox
      define combobox vehicle
         row 40
         col 110
         width 150
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
         ongotfocus _HMGAnywhereSearchInit() 
         onlostfocus _HMGAnywhereSearchClose() 
      end combobox
      define textbox qty
         row 40
         col 260
         width 80
         numeric .t.
         inputmask '999999.999'
         value 0.0
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end textbox
      define textbox amount
         row 40
         col 340
         width 80
         numeric .t.
         inputmask '999999.99'
         value 0.0
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end textbox
      define textbox reading
         row 40
         col 420
         width 80
         numeric .t.
         inputmask '99999999'
         value 0
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
//         onlostfocus savetxn()
      end textbox
      define textbox remarks
         row 40
         col 500
         width 160
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end textbox
      define button add
         row 40
         col 670
         width 20
         height 20
         picture 'save'
         tooltip 'Save Transaction'
         action savetxn()
      end button
      define grid txngrid
         row 70
         col 10
         width 680
         height 250
         headers { 'Date', 'Vehicle Regn. No.', 'Quantity', 'Amount', 'Reading', 'Remarks', 'txnid' }
         justify { 0, 0, 1, 1, 1, 0, 1 }
         widths { 100, 150, 90, 80, 80, 150, 0 }
         virtual .t.
         onquerydata txngridquery()
         ondblclick txngridmodify()
         onchange txnchanged()
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end grid         
      define grid taggrid
         row 325
         col 10
         width 680
         height 140
         headers { 'Tag', 'Group' }
         widths { 325, 325 }
         onheadclick { { || sortchange(1) }, { || sortchange(2) } }
         tooltip 'Press SPACE to Check/Uncheck a Tag'
         && ongotfocus _HMGAnywhereSearchInit() 
         && onlostfocus _HMGAnywhereSearchClose() 
//         onclick txntagchecked()
         oncheckboxclicked txntagchecked()
         justify { 0, 0 }
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end grid   
      define control context menu txngrid
         menuitem "Edit" action txngridmodify() image 'edit1' tooltip 'Edit this Transaction'
         menuitem "Delete" action deletetxn() image 'delete1' tooltip 'Delete this Transaction'
      end menu
      on key ESCAPE action if( lModifyMode, txncancelmodify(), txn.release )
   end window
   txn.taggrid.checkboxenabled := .t.

   aFont := ARRAY FONT cFontName SIZE nFontSize BOLD
   txn.taggrid.ColumnDYNAMICFONT  (1) := {|| IF ( txn.taggrid.checkboxitem( This.CellRowIndex ), aFont, NIL) }
   txn.taggrid.ColumnDYNAMICFONT  (2) := {|| IF ( txn.taggrid.checkboxitem( This.CellRowIndex ), aFont, NIL) }
   
   && Create Event ProcName _HMGAnywhereSearch( 'taggrid', 'txn', .t. ) HWND GetControlHandle ( 'taggrid', 'txn' )
   Create Event ProcName _HMGAnywhereSearch( 'vehicle', 'txn', .t. ) HWND GetControlHandle ( 'vehicle', 'txn' )
   aTable := sql( oDB, 'select regno from vehicles order by regno', @cErr )
   if hmg_len( cErr ) == 0 
      for i := 1 to hmg_len( aTable )
         txn.vehicle.additem( aTable[ i, 1 ] )
      next i
      if hmg_len( aTable ) > 0
         txn.vehicle.value := 1
      endif
   endif
   refreshtxns()
   txn.center()
   txn.activate()
return nil

function savetxn
   local lOk := .f., cErr := ''
   if txn.vehicle.value == 0
      msgstop( 'You have to select a vehicle!', 'Save Fuel Transaction' )
      return nil
   endif
   && if txn.fuel.value <= 0.0
      && msgstop( 'You have to enter valid the fuel amount!', 'Save Fuel Transaction' )
      && return nil
   && endif
   if txn.amount.value <= 0.0
      msgstop( 'You have to enter valid fuel bill amount!', 'Save Fuel Transaction' )
      return nil
   endif
   if txn.reading.value < 0
      msgstop( 'You have to enter valid odometer reading!', 'Save Fuel Transaction' )
      return nil
   endif
   && if txn.reading.value == 0
      && if .not. msgyesno( 'Odometer reading will be useful in finding the mileage of the vehicle! Are you sure to save this transaction without entering odometer reading?', 'Save Fuel Transaction' )
         && txn.reading.setfocus
         && return nil
      && endif   
   && endif
   if txn.reading.value > 0
      // check it is valid
   endif
   // proceed for saving the txn
   if lModifyMode
      // modification mode
      if nCurrentID > 0
         if msgyesno( 'Are you sure to modify this entry? You can not undo!', 'Fuel Transaction Entry' )
            lOk := miscsql( oDB, 'update txn set ' + ;
                            'date = ' + c2sql( txn.date.value ) + ', ' + ;
                            'vehicleid = ' + '( select id from vehicles where regno = ' + c2sql( txn.vehicle.item( txn.vehicle.value ) ) + ' )' + ', ' + ;
                            'qty = ' + c2sql( txn.qty.value ) + ', ' + ;
                            'amount = ' + c2sql( txn.amount.value ) + ', ' + ;
                            'remarks = ' + c2sql( txn.remarks.value ) + ', ' + ;
                            'reading = ' + c2sql( txn.reading.value ) + ' where txnid = ' + c2sql( nCurrentID ), @cErr )
            if hmg_len( cErr ) == 0
               txn.txngrid.enabled := .t.
//               txn.save.caption := 'Save'
               txn.delete.enabled := .t.
               lModifyMode := .f.
               resettxn()
               refreshtxns()
               nCurrentID := 0
               txn.txngrid.setfocus()
            else
               msgstop( 'Database Error!' )
               return nil
            endif
         else
            txn.txngrid.enabled := .t.
//            txn.save.caption := 'Save'
            txn.delete.enabled := .t.
            lModifyMode := .f.
            nCurrentID := 0
            resettxn()
            txn.txngrid.setfocus()
            return nil
         endif            
      endif   
   else         
      lOk := miscsql( oDB, 'insert into txn ( date, vehicleid, qty, amount, remarks, reading ) values ( ' + ;
                      c2sql( txn.date.value ) + ', ' + ;
                      '( select id from vehicles where regno = ' + c2sql( txn.vehicle.item( txn.vehicle.value ) ) + ' )' + ', ' + ;
                      c2sql( txn.qty.value ) + ', ' + ;
                      c2sql( txn.amount.value ) + ', ' + ;
                      c2sql( txn.remarks.value ) + ', ' + ;
                      c2sql( txn.reading.value ) + ' )', @cErr )
      if hmg_len( cErr ) > 0 .or. .not. lOk
         msgstop( cErr )   
         return nil
      else
         resettxn()
         refreshtxns()
         txn.taggrid.setfocus()
      endif
   endif   
return nil

function resettxn
   if txn.vehicle.itemcount > 0
      txn.vehicle.value := 1
   endif
   txn.qty.value := 0.0
   txn.amount.value := 0.0
   txn.reading.value := 0
   txn.remarks.value := ''
   nCurrentID := 0
   if lModifyMode
      txn.txngrid.enabled := .t.
      txn.delete.enabled := .t.
      lModifyMode := .f.
   endif
return nil
   
function refreshtxns()
   local aTable := {}, i := 0, cErr := '', lOk := .f.
   local nLineNo := 1
   txn.txngrid.itemcount := 0   
   asize( aTransactions, 0 )
   aTable := sql( oDB, 'select t.date, v.regno, t.qty, t.amount, t.reading, t.remarks, t.txnid from txn t, vehicles v where t.vehicleid = v.id order by t.date', @cErr )
   if hmg_len( cErr ) == 0
      for i := 1 to hmg_len( aTable )
         aadd( aTransactions, { dtoc( aTable[ i, 1 ] ), ;
                        aTable[ i, 2 ],;
                        alltrim( str( aTable[ i, 3 ], 12, 3 ) ),;
                        alltrim( str( aTable[ i, 4 ], 12, 2 ) ),;
                        alltrim( str( aTable[ i, 5 ], 12, 0 ) ),;
                        aTable[ i, 6 ],;
                        alltrim( str( aTable[ i, 7 ], 12, 0 ) ) } )
         if nCurrentID > 0
            // modify mode
            if aTable[ i, 7 ] == nCurrentID
               nLineNo := i
            endif
         endif   
      next i
      if hmg_len( aTable ) > 0
         txn.txngrid.itemcount := hmg_len( aTable )
         if nCurrentID > 0
            txn.txngrid.value := nLineNo
         else
            txn.txngrid.value := hmg_len( aTable )
         endif         
      endif
   endif
   update_statistics()
return nil         

function newtxnveh
   local aTable := {}, i := 0, cErr := ''
   vehmast()
   txn.vehicle.deleteallitems()
   aTable := sql( oDB, 'select regno from vehicles order by regno', @cErr )
   if hmg_len( cErr ) == 0 
      for i := 1 to hmg_len( aTable )
         txn.vehicle.additem( aTable[ i, 1 ] )
      next i
      if hmg_len( aTable ) > 0
         txn.vehicle.value := 1
      endif
   endif
return nil

function txngridquery
    This.QueryData := aTransactions[ This.QueryRowIndex, This.QueryColIndex ]
return nil

function deletetxn
   local lOk := .f.
   local aTable := {}, i := 0, cErr := ''
   local nID := 0
   local nLineNo := txn.txngrid.value
   local aLineData := {}
   if nLineNo > 0
      aLineData := aTransactions[ nLineNo ]
      nID := val( alltrim( aLineData[ 7 ] ) )
      if nID > 0
         if msgyesno( 'Are you sure to delete this entry? You can not undo!', 'Fuel Transaction Entry' )
            lOk := miscsql( oDB, 'delete from txn where txnid = ' + c2sql( nID ), @cErr )
            if hmg_len( cErr ) == 0
               refreshtxns()
            else
               msgstop( 'Database Error!' )
               return nil
            endif
         endif
      endif
   endif
return nil

function txngridmodify
   local nID := 0
   local nLineNo := txn.txngrid.value
   local aLineData := {}
   if nLineNo > 0
      aLineData := aTransactions[ nLineNo ]
      nID := val( alltrim( aLineData[ 7 ] ) )
      if nID > 0
         nCurrentID := nID
         txn.txngrid.enabled := .f.
         txn.date.value := ctod( aLineData[ 1 ] )
         for i := 1 to txn.vehicle.itemcount
            if txn.vehicle.item( i ) == aLineData[ 2 ] 
               txn.vehicle.value := i
               exit
            endif
         next i
         txn.qty.value := val( alltrim( aLineData[ 3 ] ) )
         txn.amount.value := val( alltrim( aLineData[ 4 ] ) )
         txn.reading.value := val( alltrim( aLineData[ 5 ] ) )
         txn.remarks.value := aLineData[ 6 ]
         txn.delete.enabled := .f.
         lModifyMode := .t.
         txn.date.setfocus
      endif
   endif
return nil

function sortchange( nHead )
   if nHead == 1
      if cSort == 'Group'
         cSort := 'Tag'
      endif
   else
      if cSort == 'Tag'
         cSort := 'Group'
      endif
   endif   
   txnchanged()
return nil

function txntagchecked
   local aTable := {}, i := 0, cErr := '', lOk := .f.
   local nTxnLineNo := txn.txngrid.value
   local aTxnLineData := {}
   local aLineData := {}
   local cTag := ''
   local cTagGroup := ''
   && HMG_CleanLastVirtualKeyDown()
   if nTxnLineNo == 0
      return nil
   endif
   aTxnLineData := aTransactions[ nTxnLineNo ]
   nTxnID := val( alltrim( aTxnLineData[ 7 ] ) )
   // delete all txn tags
   lOk := miscsql( oDB, 'delete from txntags where txnid = ' + c2sql( nTxnID ), @cErr )
   if hmg_len( cErr ) == 0
      if .not. lOk
         msgstop( 'Database Error!' )
         return nil
      endif
   else
      msgstop( cErr )
      return nil
   endif
   for i := 1 to txn.taggrid.itemcount
      if txn.taggrid.checkboxitem( i )
         aLineData := txn.taggrid.item( i )
         cTag := aLineData[ 1 ]
         cTagGroup := aLineData[ 2 ]
         lOk := miscsql( oDB, 'insert into txntags ( tagid, txnid ) values ( ' + ;
                         '( select tagid from tags where tagname = ' + c2sql( cTag ) + ' and catid = ( select catid from tagmaster where name = ' + c2sql( cTagGroup ) + ' ) )' + ', '  + ;
                         c2sql( nTxnID ) + ' )', @cErr )
         if hmg_len( cErr ) == 0
            if .not. lOk
               msgstop( 'Database Error' )
               return nil
            endif
         else
            msgstop( cErr )
            return nil
         endif
      endif
   next i
   txnchanged()
return nil

function txnchanged
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local nTxnLineNo := txn.txngrid.value
   local aTxnLineData := {}
   local aTagLineData := {}
   local j := 0
   local nTxnID := 0
   txn.taggrid.deleteallitems
   stopcontroleventprocedure( 'taggrid', 'txn', .t. )
   aTxnLineData := aTransactions[ nTxnLineNo ]
   nTxnID := val( alltrim( aTxnLineData[ 7 ] ) ) 
   do case
   case cSort == 'Tag'
      aTable := sql( oDB, 'select t.tagname, tm.name, case when t.tagid in ( select tagid from txntags where txnid = ' + c2sql( nTxnID ) + ') then ' + c2sql( 'A' ) + ' else ' + c2sql( 'B' ) + ' end as available from tags t, tagmaster tm where t.catid = tm.catid order by available, t.tagname, tm.name', @cErr ) 
   case cSort == 'Group'   
      aTable := sql( oDB, 'select t.tagname, tm.name, case when t.tagid in ( select tagid from txntags where txnid = ' + c2sql( nTxnID ) + ') then ' + c2sql( 'A' ) + ' else ' + c2sql( 'B' ) + ' end as available from tags t, tagmaster tm where t.catid = tm.catid order by available, tm.name, t.tagname', @cErr )
   endcase   
   if hmg_len( cErr ) == 0
      for i := 1 to hmg_len( aTable )
        txn.taggrid.additem( { aTable[ i, 1 ], aTable[ i, 2 ] } )
        if aTable[ i, 3 ] == 'A'
           txn.taggrid.checkboxitem( i ) := .t.
        endif
      next i
   else
      msgstop( cErr )   
   endif   
   if txn.taggrid.itemcount > 0
      txn.taggrid.value := 1 
   endif
   stopcontroleventprocedure( 'taggrid', 'txn', .f. )
   return nil   
return nil

function txncancelmodify
   txn.txngrid.enabled := .t.
//            txn.save.caption := 'Save'
   txn.delete.enabled := .t.
   lModifyMode := .f.
   nCurrentID := 0
   resettxn()
   txn.txngrid.setfocus()
   return nil


return nil