#include <hmg.ch>

   
function _HMGAnywhereSearch( cControlName, cWindowName, lAnywhereSearch )
   local lFound := .f.
   local nEventMsg := EventMsg()
   local ch
   local nVKDown := HMG_GetLastVirtualKeyDown()
   local cText := ''
   local nLineNo := 0
   local nItemCount := 0
   local nCol := 0
   default lAnywhereSearch := .f.
   // check whether control and window exist
   if .not. iswindowdefined( &cWindowName )
      return nil
   endif
   if .not. iscontroldefined( &cControlName, &cWindowName )
      return nil
   endif
   nCol := getproperty( cWindowName, cControlName, 'COL' )
   private cType := GetControlType( cControlName, cWindowName )
//   HMG_ChangeWindowStyle (GetControlHandle( cControlName, cWindowName ), WS_CAPTION, NIL, .F., .T.)
   ch := HMG_GetLastCharacter()
   HMG_CleanLastCharacter( .t. )
   nItemCount := GetProperty( cWindowName, cControlName, 'ITEMCOUNT' )
   do case
   case nVKDown == VK_BACK   //   backspace
      HMG_CleanLastVirtualKeyDown()
      _cAnywhereSearchStr := HB_ULEFT( _cAnywhereSearchStr, max( 0, ( HMG_Len( _cAnywhereSearchStr ) - 1 ) ) )
      _HMGAnywhereSearchUpdate( cWindowName, cControlName, .f. )
   case nVKDown == VK_UP .or. nVKDown ==  VK_DOWN 
      HMG_CleanLastVirtualKeyDown()
      if hmg_len( _cAnywhereSearchStr ) == 0
         _HMGAnywhereSearchUpdate( cWindowName, cControlName, .f. )
         return nil
      else
         nLineNo := _HMGAnywhereSearchGetRow( cWindowName, cControlName )
         if nVKDown == VK_UP
            lFound := .f.
            for i := nLineNo - 1 to 1 step - 1
               cText := _HMGAnywhereSearchGetText( cWindowName, cControlName, i )
               // first check in the starting chars... or anywhere searching if enabled
               if hmg_upper( _cAnywhereSearchStr ) == hb_uleft( hmg_upper( cText ), hmg_len( _cAnywhereSearchStr ) ) .or. if( lAnyWhereSearch, HB_UAT( hmg_upper( _cAnywhereSearchStr ), hmg_upper( cText )  ) > 0, .f. )
                  lFound := .t.
                  _HMGAnywhereSearchSetRow( cWindowName, cControlName, i )
                  exit
               endif  
            next i   
            if .not. lFound
               playbeep()
            endif                 
         else // down key search for next   
            lFound := .f.
            for i := nLineNo + 1 to nItemCount
               // first check in the starting chars...or anywhere searching if enabled
               cText := _HMGAnywhereSearchGetText( cWindowName, cControlName, i )
               if  hmg_upper( _cAnywhereSearchStr ) == hb_uleft( hmg_upper( cText ), hmg_len( _cAnywhereSearchStr ) ) .or. if( lAnyWhereSearch, HB_UAT( hmg_upper( _cAnywhereSearchStr ), hmg_upper( cText )  ) > 0, .f. )
                  lFound := .t.
                  _HMGAnywhereSearchSetRow( cWindowName, cControlName, i )
                  exit
               endif  
            next i   
            if .not. lFound
               playbeep()
            endif                 
         endif
         return 1 
      endif   
   case nVKDown == VK_ESCAPE
      HMG_CleanLastVirtualKeyDown()
      _cAnywhereSearchStr := ''
      _HMGAnywhereSearchUpdate( cWindowName, cControlName, .t. )
      return 1
   case nVKDown ==  VK_RIGHT .or. nVKDown ==  VK_LEFT .or. nVKDown ==  VK_HOME .or. nVKDown ==  VK_END .or. nVKDown == VK_RETURN
      HMG_CleanLastVirtualKeyDown()
      _cAnywhereSearchStr := ''
      _HMGAnywhereSearchUpdate( cWindowName, cControlName, .t. )
      return nil
   case EventIsMouseMessage () 
      HMG_CleanLastVirtualKeyDown()
//      _cAnywhereSearchStr := ''
      _HMGAnywhereSearchUpdate( cWindowName, cControlName, .t. )
      return nil
   case nVKDown == VK_SPACE
      if cType == 'GRID'   
         if getproperty( cWindowName, cControlName, 'CHECKBOXENABLED' )
            return nil
         else
            _cAnywhereSearchStr := _cAnywhereSearchStr + ch
            _HMGAnywhereSearchUpdate( cWindowName, cControlName, .f. )
         endif
      else   
         _cAnywhereSearchStr := _cAnywhereSearchStr + ch
         _HMGAnywhereSearchUpdate( cWindowName, cControlName, .f. )
      endif   
   otherwise
      IF nEventMsg <> WM_CHAR
         Return Nil   // enable processing the current message
      ENDIF
      _cAnywhereSearchStr := _cAnywhereSearchStr + ch
      _HMGAnywhereSearchUpdate( cWindowName, cControlName, .f. )
   endcase
   lFound := .f.
   for i := 1 to nItemCount
      // first check in the starting chars... or anywhere searching if enabled
      cText := _HMGAnywhereSearchGetText( cWindowName, cControlName, i )
      if  hmg_upper( _cAnywhereSearchStr ) == hb_uleft( hmg_upper( cText ), hmg_len( _cAnywhereSearchStr ) ) .or. if( lAnyWhereSearch, HB_UAT( hmg_upper( _cAnywhereSearchStr ), hmg_upper( cText )  ) > 0, .f. )
         lFound := .t.
         _HMGAnywhereSearchSetRow( cWindowName, cControlName, i )
         exit
      endif  
   next i   
   if .not. lFound
      playbeep()
      _cAnywhereSearchStr := HB_ULEFT( _cAnywhereSearchStr, max( 0, ( HMG_Len( _cAnywhereSearchStr ) - 1 ) ) )
      _HMGAnywhereSearchUpdate( cWindowName, cControlName, .f. )
   endif      
   return 1

function _HMGAnywhereSearchUpdate( cWindowName, cControlName, lCaptionHide )
   if iscontroldefined( _HMGAnywhereLabel, &cWindowName )
      setproperty( cWindowName, '_HMGAnywhereLabel', 'VALUE', _cAnywhereSearchStr )
   endif   
return nil

function _HMGAnywhereSearchGetRow( cWindowName, cControlName )
   local nLineNo := 0
   local aValue := {}
   local aLineData := {}
   local i := 0
   do case
   case cType == 'GRID'
      if getproperty( cWindowName, cControlName, 'CELLNAVIGATION' )
         aValue := getproperty( cWindowName, cControlName, 'VALUE' )
         if hmg_len( aValue ) > 0
            nLineNo := aValue[ 1 ]
         endif   
      else
         nLineNo := getproperty( cWindowName, cControlName, 'VALUE' )
      endif   
   case cType == 'MULTIGRID'
      if getproperty( cWindowName, cControlName, 'CELLNAVIGATION' )
         aValue := getproperty( cWindowName, cControlName, 'VALUE' )
         if hmg_len( aValue ) > 0
            if hmg_len( aValue[ 1 ] ) > 0
               nLineNo := aValue[ 1 ][ 1 ]
            endif   
         endif   
      else
         aValue := getproperty( cWindowName, cControlName, 'VALUE' )
         if hmg_len( aValue ) > 0
            nLineNo := aValue[ 1 ]
         endif   
      endif
   case cType == 'TREE' 
      // careful! Trees can be with ITEMIDs too! Find ItemIDs position
      aValue := GetProperty( cWindowName, cControlName, 'ALLVALUE' )
      for i := 1 to hmg_len( aValue )
         if aValue[ i ] == GetProperty( cWindowName, cControlName, 'VALUE' )
            // yes! this is the current position
            nLineNo := i
            exit
         endif
      next i
   case cType == 'COMBO' .or. cType == 'LIST'
      nLineNo := getproperty( cWindowName, cControlName, 'VALUE' )
   case cType == 'MULTILIST'
      aValue := getproperty( cWindowName, cControlName, 'VALUE' )
      if hmg_len( aValue ) > 0
         nLineNo := aValue[ 1 ]
      endif   
   endcase   
return nLineNo

function _HMGAnywhereSearchGetText( cWindowName, cControlName, nRow, nCol )
   local cText := ''
   local aValue := {}
   local aLineData := {}
   default nCol := 1
   do case
   case cType == 'GRID' .or. cType == 'MULTIGRID'
      cText := getproperty( cWindowName, cControlName, 'CELL', nRow, nCol )
   case cType == 'TREE' 
      // careful! Trees can be with ITEMIDs too! Find ItemID and get the text
      aValue := GetProperty( cWindowName, cControlName, 'ALLVALUE' )
      cText := GetProperty( cWindowName, cControlName, 'ITEM', aValue[ nRow ] )
   case cType == 'COMBO' .or. cType == 'LIST' .or. cType == 'MULTILIST'
      cText := getproperty( cWindowName, cControlName, 'ITEM', nRow )
   endcase   
return cText

function _HMGAnywhereSearchSetRow( cWindowName, cControlName, nRow, nCol )
   local nLineNo := 0
   local aValue := {}
   local aLineData := {}
   default nCol := 1
   do case
   case cType == 'GRID'
      if getproperty( cWindowName, cControlName, 'CELLNAVIGATION' )
         Setproperty( cWindowName, cControlName, 'VALUE', { nRow, 1 } )
      else
         setproperty( cWindowName, cControlName, 'VALUE', nRow )
      endif   
   case cType == 'MULTIGRID'
      if getproperty( cWindowName, cControlName, 'CELLNAVIGATION' )
         setproperty( cWindowName, cControlName, 'VALUE', { { nRow, 1 } } )
      else
         setproperty( cWindowName, cControlName, 'VALUE', { nRow } )
      endif   
   case cType == 'TREE' 
      // careful! Trees can be with ITEMIDs too! Find ItemID and get the text
      aValue := GetProperty( cWindowName, cControlName, 'ALLVALUE' )
      SetProperty( cWindowName, cControlName, 'VALUE', aValue[ nRow ] )
//      msginfo( str( aValue[ nRow ] ) + ', ' + str( nRow ) )
   case cType == 'COMBO' .or. cType == 'LIST'
      Setproperty( cWindowName, cControlName, 'VALUE', nRow )
   case cType == 'MULTILIST'
      setproperty( cWindowName, cControlName, 'VALUE', { nRow } )
   endcase   
return nil


function _HMGAnywhereSearchInit( lResize )
   local cWindowName := thiswindow.name
   local cControlName := this.name
   local cType := GetControlType( cControlName, cWindowName )
   local nHeight := GetProperty( cWindowName, cControlName, 'HEIGHT' )
   local nRow := GetProperty( cWindowName, cControlName, 'ROW' )
   local nCol := GetProperty( cWindowName, cControlName, 'COL' )
   local nWidth := GetProperty( cWindowName, cControlName, 'WIDTH' )
   local cFontName := GetProperty( cWindowName, cControlName, 'FONTNAME' )
   default lResize := .t.
   if .not. __mvexist( '_cAnywhereSearchStr' )
      public _cAnywhereSearchStr := ''
   endif
   if .not. iscontroldefined( _HMGAnywhereLabel, &( cWindowName ) )
      if .not. cType == 'COMBO'
         if lResize
            nHeight := nHeight - 30
            SetProperty( cWindowName, cControlName, 'HEIGHT', nHeight )
         endif   
      endif   
      define label _HMGAnywhereLabel
         parent &cWindowName
         row nRow + if( cType == 'COMBO', 30, nHeight )
         col nCol
         width nWidth
//         height nLabelHeight
         backcolor { 0, 0, 255 }
         fontcolor { 255, 255, 255 }
         fontname cFontName
         fontsize 14
         fontbold .t.
         autosize .t.
      end label
   endif   
   return nil
    
function _HMGAnywhereSearchClose( lResize )
   local cWindowName := thiswindow.name
   local cControlName := this.name
   local cType := GetControlType( cControlName, cWindowName )
   local nHeight := GetProperty( cWindowName, cControlName, 'HEIGHT' )
   local nLabelHeight := 0
   default lResize := .t.
   if __mvexist( '_cAnywhereSearchStr' )
      _cAnywhereSearchStr := ''
   endif
   if iscontroldefined( _HMGAnywhereLabel, &cWindowName )
      nLabelHeight := GetProperty( cWindowName, '_HMGAnywhereLabel', 'HEIGHT' )
      domethod( cWindowName, '_HMGAnywhereLabel', 'RELEASE' )
      if .not. cType == 'COMBO'
         if lResize 
            SetProperty( cWindowName, cControlName, 'HEIGHT', nHeight + 30 )
         endif   
      endif   
   endif
   return nil
