#include <hmg.ch>

function report 
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   private cVSort := 'Tag'
   private cTSort := 'Tag'
   private cRSort := 'Tag'
   private nVFilterType := 1 // any vehicle tag
   private nTFilterType := 1 // any transaction tag
   private nRFilterType := 1 // any reminder tag
   define window report at 0, 0 width 780 height 580 icon 'icon' title 'Report' modal nosize
      define toolbar toolbar1 imagewidth 24 imageheight 24 flat .t. strictwidth .t.
         button export  picture 'export' action exportreport() tooltip 'Save the report to a HTML file' 
         button excel  picture 'excel' action exportcsvreport() tooltip 'Save the report to a Spreadsheet (CSV) file'
         button print  picture 'print' action printreport() tooltip 'Print Report' separator

         button exit  picture 'exit' action report.release() tooltip 'Exit'
      end toolbar   
      define label fromdatelabel
         row 45
         col 10
         width 130
         value 'Transactions From '
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label
      define textbox fromdate
         row 40
         col 140
         width 110
         date .t.
         value stdate
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end textbox
      define label todatelabel
         row 45
         col 255
         width 20
         value 'To'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label
      define textbox todate
         row 40
         col 280
         width 110
         date .t.
         value date()
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end textbox
      define label typelabel
         row 45
         col 400
         width 100
         value 'Report Type'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label   
      define combobox type
         row 40
         col 500
         width 190
         items { 'Transactions Summary', 'Transactions',  'Vehicles List', 'Reminder List' }
         onchange doreport()
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end combobox
      define button report
         row 40
         col 700
         width 70
         caption 'Report'
         action doreport()
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end button
      define label vehicleslabel
         row 70
         col 10
         width 100
         value 'Vehicles'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label   
      define grid vehicles
         row 95
         col 10
         width 200
         height 120
         headers { 'Registration No.' }
         widths { 170 }
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end grid   
      define button selectveh
         row 70
         col 120
         width 24
         height 24
         picture 'select'
         tooltip 'Select all vehicles'
         action repselectall( 1 )
      end button
      define button unselectveh
         row 70
         col 150
         width 24
         height 24
         picture 'unselect'
         tooltip 'Unselect all vehicles'
         action repunselectall( 1 )
      end button
      define button inverseveh
         row 70
         col 180
         width 24
         height 24
         picture 'inverse'
         tooltip 'Vehicles Selection Inverse'
         action repselectinverse( 1 )
      end button
      define tab tagtab at 70, 210 width 450 height 145 font cFontName size nFontSize 
         define page "Vehicle Tags"
            define grid vtags
               row 25
               col 0
               width 450
               height 120
               headers { 'Tag', 'Tag Group', 'TagID' }
               onheadclick { { || repsortvchange(1) }, { || repsortvchange(2) }, { || nil } }
               widths { 210, 210, 0 }
               fontname cFontName
               fontsize nFontSize
               fontbold lFontBold
            end grid   
         end page
         define page "Transaction Tags"
            define grid ttags
               row 25
               col 0
               width 450
               height 120
               headers { 'Tag', 'Tag Group', 'TagID' }
               onheadclick { { || repsorttchange(1) }, { || repsorttchange(2) }, { || nil } }
               widths { 210, 210, 0 }
               fontname cFontName
               fontsize nFontSize
               fontbold lFontBold
            end grid   
         end page
         define page "Reminder Tags"
            define grid rtags
               row 25
               col 0
               width 450
               height 120
               headers { 'Tag', 'Tag Group', 'TagID' }
               onheadclick { { || repsortrchange(1) }, { || repsortrchange(2) }, { || nil }  }
               widths { 210, 210, 0 }
               fontname cFontName
               fontsize nFontSize
               fontbold lFontBold
            end grid   
         end page
      end tab         
      define button selecttag
         row 70
         col 560
         width 24
         height 24
         picture 'select'
         tooltip 'Select all Tags'
         action repselectall( 2 )
      end button
      define button unselecttag
         row 70
         col 590
         width 24
         height 24
         picture 'unselect'
         tooltip 'Unselect all Tags'
         action repunselectall( 2 )
      end button
      define button inversetag
         row 70
         col 620
         width 24
         height 24
         picture 'inverse'
         tooltip 'Tags Selection Inverse'
         action repselectinverse( 2 )
      end button
      define label includelabel
         row 75
         col 670
         width 105
         value 'Use Tags'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label
      define checkbox vinclude
         row 110
         col 670
         width 105
         caption 'Vehicle'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end checkbox
      define checkbox tinclude
         row 140
         col 670
         width 105
         caption 'Transaction'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end checkbox
      define checkbox rinclude
         row 170
         col 670
         width 105
         caption 'Reminder'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end checkbox
      && define checkbox useand
         && row 200
         && col 670
         && width 105
         && caption 'Combined Search'
         && fontname cFontName
         && fontsize nFontSize
         && fontbold lFontBold
      && end checkbox
      define control context menu vehicles
         menuitem "Select All" action repselectall( 1 ) image 'select'
         menuitem "UnSelect All" action repunselectall( 1 ) image 'unselect'
         menuitem "Inverse Selection" action repselectinverse( 1 ) image 'inverse'
      end menu
      VTagContext()
      TTagContext()
      RTagContext()
      on key ESCAPE action report.release
   end window
   report.vtags.backgroundimage( GRID_SETBKIMAGE_WATERMARK, 'vehtag', 0, 0 ) 
   report.rtags.backgroundimage( GRID_SETBKIMAGE_WATERMARK, 'remind', 0, 0 ) 
   report.ttags.backgroundimage( GRID_SETBKIMAGE_WATERMARK, 'trantag', 0, 0 ) 
   report.vehicles.checkboxenabled := .t.
   report.vtags.checkboxenabled := .t.
   report.ttags.checkboxenabled := .t.
   report.rtags.checkboxenabled := .t.
   aTable := sql( oDB, 'select regno from vehicles order by regno', @cErr )
   if hmg_len( cErr ) == 0
      for i := 1 to hmg_len( aTable )
         report.vehicles.additem( { aTable[ i, 1 ] } )
      next i
      if hmg_len( aTable ) > 0
         report.vehicles.value := 1
         report.vehicles.checkboxallitems := .t.
      endif
   endif
   repsortvchange( 1 )
   repsorttchange( 1 )
   repsortrchange( 1 )
   report.type.value := 1 
   report.center
   report.activate
return nil


function repsortvchange( nHead )
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   report.vtags.deleteallitems()
   report.vtags.disableupdate()
   if nHead == 1
      if cVSort == 'Group'
         cVSort := 'Tag'
      endif
   else
      if cVSort == 'Tag'
         cVSort := 'Group'
      endif
   endif   
   do case
   case cVSort == 'Tag'
      aTable := sql( oDB, 'select t.tagname, tm.name, t.tagid from tags t, tagmaster tm where t.catid = tm.catid and t.tagid in ( select distinct tagid from generaltags ) order by t.tagname, tm.name', @cErr ) 
   case cVSort == 'Group'   
      aTable := sql( oDB, 'select t.tagname, tm.name, t.tagid from tags t, tagmaster tm where t.catid = tm.catid and t.tagid in ( select distinct tagid from generaltags ) order by tm.name, t.tagname', @cErr ) 
   endcase   
   if hmg_len( cErr ) == 0
      for i := 1 to hmg_len( aTable )
        report.vtags.additem( { aTable[ i, 1 ], aTable[ i, 2 ], alltrim( str( aTable[ i, 3 ] ) ) } )
      next i
   else
      msgstop( cErr )   
   endif   
   if report.vtags.itemcount > 0
      report.vtags.value := 1 
      report.vtags.checkboxallitems := .t.
   endif
   report.vtags.enableupdate()
return nil

function repsorttchange( nHead )
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   report.ttags.deleteallitems()
   report.ttags.disableupdate()
   if nHead == 1
      if cTSort == 'Group'
         cTSort := 'Tag'
      endif
   else
      if cTSort == 'Tag'
         cTSort := 'Group'
      endif
   endif   
   do case
   case cTSort == 'Tag'
      aTable := sql( oDB, 'select t.tagname, tm.name, t.tagid from tags t, tagmaster tm where t.catid = tm.catid and t.tagid in ( select distinct tagid from txntags ) order by t.tagname, tm.name', @cErr ) 
   case cTSort == 'Group'   
      aTable := sql( oDB, 'select t.tagname, tm.name, t.tagid from tags t, tagmaster tm where t.catid = tm.catid and t.tagid in ( select distinct tagid from txntags ) order by tm.name, t.tagname', @cErr ) 
   endcase   
   if hmg_len( cErr ) == 0
      for i := 1 to hmg_len( aTable )
        report.ttags.additem( { aTable[ i, 1 ], aTable[ i, 2 ], alltrim( str( aTable[ i, 3 ] ) ) } )
      next i
   else
      msgstop( cErr )   
   endif   
   if report.ttags.itemcount > 0
      report.ttags.value := 1 
      report.ttags.checkboxallitems := .t.
   endif
   report.ttags.enableupdate()
return nil

function repsortrchange( nHead )
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   report.rtags.deleteallitems()
   report.rtags.disableupdate()
   if nHead == 1
      if cRSort == 'Group'
         cRSort := 'Tag'
      endif
   else
      if cRSort == 'Tag'
         cRSort := 'Group'
      endif
   endif   
   do case
   case cRSort == 'Tag'
      aTable := sql( oDB, 'select t.tagname, tm.name, t.tagid from tags t, tagmaster tm where t.catid = tm.catid and t.tagid in ( select distinct tagid from reminder ) order by t.tagname, tm.name', @cErr ) 
   case cRSort == 'Group'   
      aTable := sql( oDB, 'select t.tagname, tm.name, t.tagid from tags t, tagmaster tm where t.catid = tm.catid and t.tagid in ( select distinct tagid from reminder ) order by tm.name, t.tagname', @cErr ) 
   endcase   
   if hmg_len( cErr ) == 0
      for i := 1 to hmg_len( aTable )
        report.rtags.additem( { aTable[ i, 1 ], aTable[ i, 2 ], alltrim( str( aTable[ i, 3 ] ) ) } )
      next i
   else
      msgstop( cErr )   
   endif   
   if report.rtags.itemcount > 0
      report.rtags.value := 1 
      report.rtags.checkboxallitems := .t.
   endif
   report.rtags.enableupdate()
return nil

function repselectall( nMode )
   local nTab := report.tagtab.value
   do case
   case nMode == 1
      // vehicles
      report.vehicles.checkboxallitems := .t.
   case nMode == 2 
      // tags
      do case
      case nTab == 1 // vtags
         report.vtags.checkboxallitems := .t.
      case nTab == 2 // ttags
         report.ttags.checkboxallitems := .t.
      case nTab == 3 // ttags
         report.rtags.checkboxallitems := .t.
      endcase
   endcase
return nil

function repunselectall( nMode )
   local nTab := report.tagtab.value
   do case
   case nMode == 1
      // vehicles
      report.vehicles.checkboxallitems := .f.
   case nMode == 2 
      // tags
      do case
      case nTab == 1 // vtags
         report.vtags.checkboxallitems := .f.
      case nTab == 2 // ttags
         report.ttags.checkboxallitems := .f.
      case nTab == 3 // ttags
         report.rtags.checkboxallitems := .f.
      endcase
   endcase
return nil

function repselectinverse( nMode )
   local nTab := report.tagtab.value
   local i := 0
   do case
   case nMode == 1
      // vehicles
      for i := 1 to report.vehicles.itemcount
         if report.vehicles.checkboxitem( i )
            report.vehicles.checkboxitem( i ) := .f.
         else
            report.vehicles.checkboxitem( i ) := .t.
         endif
      next i   
   case nMode == 2 
      // tags
      do case
      case nTab == 1 // vtags
         for i := 1 to report.vtags.itemcount
            if report.vtags.checkboxitem( i )
               report.vtags.checkboxitem( i ) := .f.
            else
               report.vtags.checkboxitem( i ) := .t.
            endif
         next i   
      case nTab == 2 // ttags
         for i := 1 to report.vtags.itemcount
            if report.ttags.checkboxitem( i )
               report.ttags.checkboxitem( i ) := .f.
            else
               report.ttags.checkboxitem( i ) := .t.
            endif
         next i   
      case nTab == 3 // ttags
         for i := 1 to report.vtags.itemcount
            if report.rtags.checkboxitem( i )
               report.rtags.checkboxitem( i ) := .f.
            else
               report.rtags.checkboxitem( i ) := .t.
            endif
         next i   
      endcase
   endcase
return nil

function doreport
   do case
   case report.type.value == 1
      dotxnsummaryreport()
   case report.type.value == 2
      dotxnreport()
   case report.type.value == 3
      dovehlistreport()
   case report.type.value == 4
      doreminderreport()
   endcase
return nil

function dotxnsummaryreport
   local aTable := {}, i := 0, cErr := '', lOk := .f.
   local aVehicles := {}
   local aVTags := {}, aRTags := {}, aTTags := {}
   local cRegNo := ''
   local nTag := 0
   local nTotal := 0.0
   local nTotQty := 0.0
   if iscontroldefined( 'reportgrid', 'report' )
      report.reportgrid.release
   endif
   if report.fromdate.value > report.todate.value
      msgstop( 'Invalid date specification! ' )
      return nil
   endif
   cQStr := 'select v.regno, sum( t.qty ), sum( t.amount ) from txn t, vehicles v where t.vehicleid = v.id and t.date >= ' + c2sql( report.fromdate.value ) + ' and t.date <= ' + c2sql( report.todate.value )
   aVehicles := {}
   for i := 1 to report.vehicles.itemcount
      if report.vehicles.checkboxitem( i )
         aadd( aVehicles, i )
      endif
   next i
   if hmg_len( aVehicles ) == 0
      msgstop( 'You have to select at least one vehicle!', 'Report' )
      return nil
   endif
   cQStr := cQStr + ' and t.vehicleid in ( select id from vehicles where regno in ( '
   for i := 1 to hmg_len( aVehicles )
      aLineData := report.vehicles.item( aVehicles[ i ] )
      cRegNo := aLineData[ 1 ]
      cQStr := cQStr + c2sql( cRegNo )
      if i < hmg_len( aVehicles )
         cQStr := cQStr + ', '
      endif
   next i         
   cQStr := cQStr + ' ) )'
   // tag selection 
   
   if report.vinclude.value
      aVTags := {}
      for i := 1 to report.vtags.itemcount
         if report.vtags.checkboxitem( i )
            aadd( aVTags, i )
         endif
      next i
      if hmg_len( aVTags ) == 0
         msgstop( 'You have to select at least one vehicle tag if you want to filter vehicle tags', 'Report' )
         return nil
      endif
      if nVFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and t.vehicleid in ( select vehicleid from generaltags where tagid in ( '
         for i := 1 to hmg_len( aVTags )
            aLineData := report.vtags.item( aVTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aVTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' ) )'
      else  // all tags 
         cQStr := cQStr + ' and ( '
         for i := 1 to hmg_len( aVTags )
            aLineData := report.vtags.item( aVTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + 'exists ( select g.vehicleid from generaltags g where g.vehicleid = t.vehicleid and g.tagid = ' + c2sql( nTag ) + ' )' 
            if i < hmg_len( aVTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' )'
      endif
   endif
   if report.tinclude.value
      aTTags := {}
      for i := 1 to report.ttags.itemcount
         if report.ttags.checkboxitem( i )
            aadd( aTTags, i )
         endif
      next i
      if hmg_len( aTTags ) == 0
         msgstop( 'You have to select at least transaction tag if you want to filter using transaction tags', 'Report' )
         return nil
      endif
      if nTFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and t.txnid in ( select txnid from txntags where tagid in ( '
         for i := 1 to hmg_len( aTTags )
            aLineData := report.ttags.item( aTTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aTTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' ) )'
      else // all tags
         cQStr := cQStr + ' and ( '
         for i := 1 to hmg_len( aTTags )
            aLineData := report.ttags.item( aTTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + ' exists ( select tt.txnid from txntags tt where tt.txnid = t.txnid and tt.tagid = ' + c2sql( nTag ) + ' )'
            if i < hmg_len( aTTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' )'
      endif      
   endif
   if report.rinclude.value
      aRTags := {}
      for i := 1 to report.rtags.itemcount
         if report.rtags.checkboxitem( i )
            aadd( aRTags, i )
         endif
      next i
      if hmg_len( aRTags ) == 0
         msgstop( 'You have to select at least one reminder if you want to filter using reminder tags', 'Report' )
         return nil
      endif
      if nRFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and t.vehicleid in ( select vehicleid from reminder where tagid in ( '
         for i := 1 to hmg_len( aRTags )
            aLineData := report.rtags.item( aRTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aRTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' ) )'
      else
         cQStr := cQStr + ' and ( '
         for i := 1 to hmg_len( aRTags )
            aLineData := report.rtags.item( aRTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + ' exists ( select r.vehicleid from reminder r where r.vehicleid = t.vehicleid and r.tagid = ' + c2sql( nTag ) + ' )'
            if i < hmg_len( aRTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' )'
      endif
   endif
   cQStr := cQStr + ' group by v.id order by sum( t.amount ) desc'
   system.clipboard := cQStr
   aTable := sql( oDB, cQStr, @cErr )   
   if hmg_len( cErr ) == 0
      if hmg_len( aTable ) > 0
         define grid reportgrid
            row 220
            col 10
            width 760
            height 325
            parent report
            headers { 'Registration Number', 'Quantity', 'Rate', 'Amount' }
            widths { 320, 140, 120, 140 }
            backcolor { 255, 255, 200 }
            justify { 0, 1, 1, 1 }
            fontname cFontName
            fontsize nFontSize
            fontbold lFontBold
         end grid
         for i := 1 to hmg_len( aTable )         
            if val( alltrim( aTable[ i, 2 ] ) ) > 0.0 .and. val( alltrim( aTable[ i, 3 ] ) ) > 0.0
               nRate := val( alltrim( aTable[ i, 3 ] ) ) / val( alltrim( aTable[ i, 2 ] ) ) 
            else
               nRate := 0.0
            endif               
            report.reportgrid.additem( { aTable[ i, 1 ], ;   // regn no.
                                alltrim( transform( val( alltrim( aTable[ i, 2 ] ) ), '999999999.999' ) ), ; // qty
                                alltrim( str( nRate, 12, 2 ) ), ; // rate
                                alltrim( transform( val( alltrim( aTable[ i, 3 ] ) ), '999999999.99' ) ) ; //   amount  
                                } ) 
            nTotal := nTotal + val( alltrim( aTable[ i, 3 ] ) )
            nTotQty := nTotQty + val( alltrim( aTable[ i, 2 ] ) )
         next i
         report.reportgrid.additem( { '', '', '', '' } )
         report.reportgrid.additem( { '    Total', alltrim( str( nTotQty, 12, 3 ) ), '', alltrim( str( nTotal, 14, 2 ) ) } )
         report.reportgrid.value := report.reportgrid.itemcount
      endif
   else
      msgstop( cErr )   
   endif
return nil


function dotxnreport
   local aTable := {}, i := 0, cErr := '', lOk := .f.
   local aVehicles := {}
   local aVTags := {}, aRTags := {}, aTTags := {}
   local cRegNo := ''
   local nTag := 0
   local nTotal := 0.0
   local nTotQty := 0.0
   if iscontroldefined( 'reportgrid', 'report' )
      report.reportgrid.release
   endif
   if report.fromdate.value > report.todate.value
      msgstop( 'Invalid date specification! ' )
      return nil
   endif
   cQStr := 'select t.date, v.regno, t.qty, case when t.qty > 0.0 then t.amount / t.qty else 0.0 end as rate, t.amount, t.reading, t.remarks, t.txnid from txn t, vehicles v where t.vehicleid = v.id and t.date >= ' + c2sql( report.fromdate.value ) + ' and t.date <= ' + c2sql( report.todate.value )
   aVehicles := {}
   for i := 1 to report.vehicles.itemcount
      if report.vehicles.checkboxitem( i )
         aadd( aVehicles, i )
      endif
   next i
   if hmg_len( aVehicles ) == 0
      msgstop( 'You have to select at least one vehicle!', 'Report' )
      return nil
   endif
   cQStr := cQStr + ' and t.vehicleid in ( select id from vehicles where regno in ( '
   for i := 1 to hmg_len( aVehicles )
      aLineData := report.vehicles.item( aVehicles[ i ] )
      cRegNo := aLineData[ 1 ]
      cQStr := cQStr + c2sql( cRegNo )
      if i < hmg_len( aVehicles )
         cQStr := cQStr + ', '
      endif
   next i         
   cQStr := cQStr + ' ) )'
   if report.vinclude.value
      aVTags := {}
      for i := 1 to report.vtags.itemcount
         if report.vtags.checkboxitem( i )
            aadd( aVTags, i )
         endif
      next i
      if hmg_len( aVTags ) == 0
         msgstop( 'You have to select at least one vehicle if you want to filter vehicle tags', 'Report' )
         return nil
      endif
      if nVFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and t.vehicleid in ( select vehicleid from generaltags where tagid in ( '
         for i := 1 to hmg_len( aVTags )
            aLineData := report.vtags.item( aVTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aVTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' ) )'
      else  // all tags 
         cQStr := cQStr + ' and ( '
         for i := 1 to hmg_len( aVTags )
            aLineData := report.vtags.item( aVTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + 'exists ( select g.vehicleid from generaltags g where g.vehicleid = t.vehicleid and g.tagid = ' + c2sql( nTag ) + ' )' 
            if i < hmg_len( aVTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' )'
      endif
   endif
   if report.tinclude.value
      aTTags := {}
      for i := 1 to report.ttags.itemcount
         if report.ttags.checkboxitem( i )
            aadd( aTTags, i )
         endif
      next i
      if hmg_len( aTTags ) == 0
         msgstop( 'You have to select at least transaction tag if you want to filter using transaction tags', 'Report' )
         return nil
      endif
      if nTFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and t.txnid in ( select txnid from txntags where tagid in ( '
         for i := 1 to hmg_len( aTTags )
            aLineData := report.ttags.item( aTTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aTTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' ) )'
      else // all tags
         cQStr := cQStr + ' and ( '
         for i := 1 to hmg_len( aTTags )
            aLineData := report.ttags.item( aTTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + ' exists ( select tt.txnid from txntags tt where tt.txnid = t.txnid and tt.tagid = ' + c2sql( nTag ) + ' )'
            if i < hmg_len( aTTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' )'
      endif      
   endif
   if report.rinclude.value
      aRTags := {}
      for i := 1 to report.rtags.itemcount
         if report.rtags.checkboxitem( i )
            aadd( aRTags, i )
         endif
      next i
      if hmg_len( aRTags ) == 0
         msgstop( 'You have to select at least one reminder if you want to filter using reminder tags', 'Report' )
         return nil
      endif
      if nRFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and t.vehicleid in ( select vehicleid from reminder where tagid in ( '
         for i := 1 to hmg_len( aRTags )
            aLineData := report.rtags.item( aRTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aRTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' ) )'
      else
         cQStr := cQStr + ' and ( '
         for i := 1 to hmg_len( aRTags )
            aLineData := report.rtags.item( aRTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + ' exists ( select r.vehicleid from reminder r where r.vehicleid = t.vehicleid and r.tagid = ' + c2sql( nTag ) + ' )'
            if i < hmg_len( aRTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' )'
      endif
   endif
   cQStr := cQStr + ' order by t.date'
   system.clipboard := cQStr
   aTable := sql( oDB, cQStr, @cErr )   
   if hmg_len( cErr ) == 0
      if hmg_len( aTable ) > 0
         define grid reportgrid
            row 220
            col 10
            width 760
            height 325
            parent report
            headers { 'Date', 'Registration Number', 'Quantity', 'Rate', 'Amount', 'Reading', 'Remarks' }
            widths { 120, 150, 100, 60, 120, 80, 100 }
            backcolor { 200, 255, 200 }
            justify { 0, 0, 1, 1, 1, 1, 0 }
            fontname cFontName
            fontsize nFontSize
            fontbold lFontBold
         end grid
         for i := 1 to hmg_len( aTable )         
            report.reportgrid.additem( { dtoc( aTable[ i, 1 ] ), ;  // txn date
                                aTable[ i, 2 ], ;   // regn no.
                                alltrim( str( aTable[ i, 3 ], 12, 3 ) ), ; // qty
                                alltrim( transform( val( alltrim( aTable[ i, 4 ] ) ), '999999999.99' ) ), ; // rate if any
                                alltrim( str( aTable[ i, 5 ], 14, 2  ) ), ; // amount
                                alltrim( str( aTable[ i, 6 ], 12, 0 ) ), ; // reading
                                aTable[ i, 7 ]  } ) // remarks
            nTotal := nTotal + aTable[ i, 5 ]
            nTotQty := nTotQty + aTable[ i, 3 ]
         next i
         report.reportgrid.additem( { '', '', '', '', '', '', '' } )                  
         report.reportgrid.additem( { '', '    Total', alltrim( str( nTotQty, 12, 3 ) ), '', alltrim( str( nTotal, 14, 2 ) ), '', '' } )                  
         report.reportgrid.value := report.reportgrid.itemcount
      endif
   else
      msgstop( cErr )   
   endif
return nil


function dovehlistreport
   local aTable := {}, i := 0, cErr := '', lOk := .f.
   local aVehicles := {}
   local aVTags := {}, aRTags := {}, aTTags := {}
   local cRegNo := ''
   local nTag := 0
   if iscontroldefined( 'reportgrid', 'report' )
      report.reportgrid.release
   endif
   if report.fromdate.value > report.todate.value
      msgstop( 'Invalid date specification! ' )
      return nil
   endif
   cQStr := 'select distinct v.regno from vehicles v where '
   aVehicles := {}
   for i := 1 to report.vehicles.itemcount
      if report.vehicles.checkboxitem( i )
         aadd( aVehicles, i )
      endif
   next i
   if hmg_len( aVehicles ) == 0
      msgstop( 'You have to select at least one vehicle!', 'Report' )
      return nil
   endif
   cQStr := cQStr + ' v.id in ( select id from vehicles where regno in ( '
   for i := 1 to hmg_len( aVehicles )
      aLineData := report.vehicles.item( aVehicles[ i ] )
      cRegNo := aLineData[ 1 ]
      cQStr := cQStr + c2sql( cRegNo )
      if i < hmg_len( aVehicles )
         cQStr := cQStr + ', '
      endif
   next i         
   cQStr := cQStr + ' ) )'
   // tag selection 
   
   if report.vinclude.value
      aVTags := {}
      for i := 1 to report.vtags.itemcount
         if report.vtags.checkboxitem( i )
            aadd( aVTags, i )
         endif
      next i
      if hmg_len( aVTags ) == 0
         msgstop( 'You have to select at least one vehicle tag if you want to filter vehicle tags', 'Report' )
         return nil
      endif
      if nVFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and v.id in ( select vehicleid from generaltags where tagid in ( '
         for i := 1 to hmg_len( aVTags )
            aLineData := report.vtags.item( aVTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aVTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' ) )'
      else  // all tags 
         cQStr := cQStr + ' and ( '
         for i := 1 to hmg_len( aVTags )
            aLineData := report.vtags.item( aVTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + 'exists ( select g.vehicleid from generaltags g where g.vehicleid = v.id and g.tagid = ' + c2sql( nTag ) + ' )' 
            if i < hmg_len( aVTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' )'
      endif
   endif
   if report.tinclude.value
      aTTags := {}
      for i := 1 to report.ttags.itemcount
         if report.ttags.checkboxitem( i )
            aadd( aTTags, i )
         endif
      next i
      if hmg_len( aTTags ) == 0
         msgstop( 'You have to select at least transaction tag if you want to filter using transaction tags', 'Report' )
         return nil
      endif
      if nTFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and exists ( select t.vehicleid from txn t where t.vehicleid = v.id and t.date >= ' + c2sql( report.fromdate.value ) + ' and t.date <= ' + c2sql( report.todate.value ) + ' and t.txnid in ( select txnid from txntags where tagid in ( '
         for i := 1 to hmg_len( aTTags )
            aLineData := report.ttags.item( aTTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aTTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' ) ) ) '
      else // all tags
         cQStr := cQStr + ' and exists ( select t.vehicleid from txn t where t.vehicleid = v.id and t.date >= ' + c2sql( report.fromdate.value ) + ' and t.date <= ' + c2sql( report.todate.value ) + ' and ( '
         for i := 1 to hmg_len( aTTags )
            aLineData := report.ttags.item( aTTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + ' exists ( select tt.txnid from txntags tt where tt.txnid = t.txnid and tt.tagid = ' + c2sql( nTag ) + ' )'
            if i < hmg_len( aTTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' ) )'
      endif      
   endif
   if report.rinclude.value
      aRTags := {}
      for i := 1 to report.rtags.itemcount
         if report.rtags.checkboxitem( i )
            aadd( aRTags, i )
         endif
      next i
      if hmg_len( aRTags ) == 0
         msgstop( 'You have to select at least one reminder if you want to filter using reminder tags', 'Report' )
         return nil
      endif
      if nRFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and v.id in ( select vehicleid from reminder where tagid in ( '
         for i := 1 to hmg_len( aRTags )
            aLineData := report.rtags.item( aRTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aRTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' ) )'
      else
         cQStr := cQStr + ' and ( '
         for i := 1 to hmg_len( aRTags )
            aLineData := report.rtags.item( aRTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + ' exists ( select r.vehicleid from reminder r where r.vehicleid = v.id and r.tagid = ' + c2sql( nTag ) + ' )'
            if i < hmg_len( aRTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' )'
      endif
   endif
   cQStr := cQStr + ' order by v.regno'
   system.clipboard := cQStr
   aTable := sql( oDB, cQStr, @cErr )   
   if hmg_len( cErr ) == 0
      if hmg_len( aTable ) > 0
         define grid reportgrid
            row 220
            col 10
            width 430
            height 325
            parent report
            headers { 'Sl.No.', 'Registration Number' }
            widths { 100, 300 }
            backcolor { 255, 200, 255 }
            justify { 1, 0 }
            fontname cFontName
            fontsize nFontSize
            fontbold lFontBold
         end grid
         for i := 1 to hmg_len( aTable )         
            report.reportgrid.additem( { alltrim( str( i ) ), aTable[ i, 1 ] } ) 
         next i
         report.reportgrid.value := 1
      endif
   else
      msgstop( cErr )   
   endif
return nil

function doreminderreport
   local aTable := {}, i := 0, cErr := '', lOk := .f.
   local aVehicles := {}
   local aVTags := {}, aRTags := {}, aTTags := {}
   local cRegNo := ''
   local nTag := 0
   if iscontroldefined( 'reportgrid', 'report' )
      report.reportgrid.release
   endif
   if report.fromdate.value > report.todate.value
      msgstop( 'Invalid date specification! ' )
      return nil
   endif
   cQStr := 'select distinct v.regno, tag.tagname, tm.name, r.date from vehicles v, tags tag, tagmaster tm, reminder r where r.vehicleid = v.id and r.tagid = tag.tagid and tag.catid = tm.catid'
   aVehicles := {}
   for i := 1 to report.vehicles.itemcount
      if report.vehicles.checkboxitem( i )
         aadd( aVehicles, i )
      endif
   next i
   if hmg_len( aVehicles ) == 0
      msgstop( 'You have to select at least one vehicle!', 'Report' )
      return nil
   endif
   cQStr := cQStr + ' and v.id in ( select id from vehicles where regno in ( '
   for i := 1 to hmg_len( aVehicles )
      aLineData := report.vehicles.item( aVehicles[ i ] )
      cRegNo := aLineData[ 1 ]
      cQStr := cQStr + c2sql( cRegNo )
      if i < hmg_len( aVehicles )
         cQStr := cQStr + ', '
      endif
   next i         
   cQStr := cQStr + ' ) )'
   // tag selection 
   
   if report.vinclude.value
      aVTags := {}
      for i := 1 to report.vtags.itemcount
         if report.vtags.checkboxitem( i )
            aadd( aVTags, i )
         endif
      next i
      if hmg_len( aVTags ) == 0
         msgstop( 'You have to select at least one vehicle tag if you want to filter vehicle tags', 'Report' )
         return nil
      endif
      if nVFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and v.id in ( select vehicleid from generaltags where tagid in ( '
         for i := 1 to hmg_len( aVTags )
            aLineData := report.vtags.item( aVTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aVTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' ) )'
      else  // all tags 
         cQStr := cQStr + ' and ( '
         for i := 1 to hmg_len( aVTags )
            aLineData := report.vtags.item( aVTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + 'exists ( select g.vehicleid from generaltags g where g.vehicleid = v.id and g.tagid = ' + c2sql( nTag ) + ' )' 
            if i < hmg_len( aVTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' )'
      endif
   endif
   if report.tinclude.value
      aTTags := {}
      for i := 1 to report.ttags.itemcount
         if report.ttags.checkboxitem( i )
            aadd( aTTags, i )
         endif
      next i
      if hmg_len( aTTags ) == 0
         msgstop( 'You have to select at least transaction tag if you want to filter using transaction tags', 'Report' )
         return nil
      endif
      if nTFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and exists ( select t.vehicleid from txn t where t.vehicleid = v.id and t.date >= ' + c2sql( report.fromdate.value ) + ' and t.date <= ' + c2sql( report.todate.value ) + ' and t.txnid in ( select txnid from txntags where tagid in ( '
         for i := 1 to hmg_len( aTTags )
            aLineData := report.ttags.item( aTTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aTTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' ) ) ) '
      else // all tags
         cQStr := cQStr + ' and exists ( select t.vehicleid from txn t where t.vehicleid = v.id and t.date >= ' + c2sql( report.fromdate.value ) + ' and t.date <= ' + c2sql( report.todate.value ) + ' and ( '
         for i := 1 to hmg_len( aTTags )
            aLineData := report.ttags.item( aTTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + ' exists ( select tt.txnid from txntags tt where tt.txnid = t.txnid and tt.tagid = ' + c2sql( nTag ) + ' )'
            if i < hmg_len( aTTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' ) )'
      endif      
   endif
   if report.rinclude.value
      aRTags := {}
      for i := 1 to report.rtags.itemcount
         if report.rtags.checkboxitem( i )
            aadd( aRTags, i )
         endif
      next i
      if hmg_len( aRTags ) == 0
         msgstop( 'You have to select at least one reminder if you want to filter using reminder tags', 'Report' )
         return nil
      endif
      if nRFilterType == 1 // any tag - either or
         cQStr := cQStr + ' and r.tagid in ( '
         for i := 1 to hmg_len( aRTags )
            aLineData := report.rtags.item( aRTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + c2sql( nTag )
            if i < hmg_len( aRTags )
               cQStr := cQStr + ', '
            endif
         next i         
         cQStr := cQStr + ' )'
      else
         cQStr := cQStr + ' and ( '
         for i := 1 to hmg_len( aRTags )
            aLineData := report.rtags.item( aRTags[ i ] )
            nTag := val( aLineData[ 3 ] )
            cQStr := cQStr + ' ( r.tagid = ' + c2sql( nTag ) + ' )'
            if i < hmg_len( aRTags )
               cQStr := cQStr + ' and '
            endif
         next i         
         cQStr := cQStr + ' )'
      endif
   endif
   cQStr := cQStr + ' order by r.date, v.regno'
   system.clipboard := cQStr
   aTable := sql( oDB, cQStr, @cErr )   
   if hmg_len( cErr ) == 0
      if hmg_len( aTable ) > 0
         define grid reportgrid
            row 220
            col 10
            width 690
            height 325
            parent report
            headers { 'Sl.No.', 'Registration Number', 'Tag Name', 'Group', 'Date' }
            widths { 60, 200, 160, 120, 120 }
            backcolor { 200, 255, 255 }
            justify { 1, 0, 0, 0, 0 }
            fontname cFontName
            fontsize nFontSize
            fontbold lFontBold
         end grid
         for i := 1 to hmg_len( aTable )         
            report.reportgrid.additem( { alltrim( str( i ) ), aTable[ i, 1 ], aTable[ i, 2 ], aTable[ i, 3 ], dtoc( aTable[ i, 4 ] ) } ) 
         next i
         report.reportgrid.value := 1
      endif
   else
      msgstop( cErr )   
   endif
return nil

function VTagContext
   If IsControlContextMenuDefined( 'vtags', 'report' )
      ReleaseControlContextMenu( 'vtags', 'report' )
   Endif
   define control context menu vtags of report
      menuitem "Select All" action repselectall( 2 ) image 'select'
      menuitem "UnSelect All" action repunselectall( 2 ) image 'unselect'
      menuitem "Inverse Selection" action repselectinverse( 2 ) image 'inverse'
      separator
      if nVFilterType == 1 // any tag      
         menuitem "Any Tag" action ( nVFilterType := 1, VTagContext() ) checked
      else
         menuitem "Any Tag" action ( nVFilterType := 1, VTagContext() ) 
      endif
      if nVFilterType == 2 // all tags
         menuitem "All Tags" action ( nVFilterType := 2, VTagContext() ) checked
      else
         menuitem "All Tags" action ( nVFilterType := 2, VTagContext() ) 
      endif
   end menu
return nil

function TTagContext
   If IsControlContextMenuDefined( 'ttags', 'report' )
      ReleaseControlContextMenu( 'ttags', 'report' )
   Endif
   define control context menu ttags of report
      menuitem "Select All" action repselectall( 2 ) image 'select'
      menuitem "UnSelect All" action repunselectall( 2 ) image 'unselect'
      menuitem "Inverse Selection" action repselectinverse( 2 ) image 'inverse'
      separator
      if nTFilterType == 1 // any tag      
         menuitem "Any Tag" action ( nTFilterType := 1, TTagContext() ) checked
      else
         menuitem "Any Tag" action ( nTFilterType := 1, TTagContext() ) 
      endif
      if nTFilterType == 2 // all tags
         menuitem "All Tags" action ( nTFilterType := 2, TTagContext() ) checked
      else
         menuitem "All Tags" action ( nTFilterType := 2, TTagContext() ) 
      endif
   end menu
return nil

function RTagContext
   If IsControlContextMenuDefined( 'rtags', 'report' )
      ReleaseControlContextMenu( 'rtags', 'report' )
   Endif
   define control context menu rtags OF report
      menuitem "Select All" action repselectall( 2 ) image 'select'
      menuitem "UnSelect All" action repunselectall( 2 ) image 'unselect'
      menuitem "Inverse Selection" action repselectinverse( 2 ) image 'inverse'
      separator
      if nRFilterType == 1 // any tag      
         menuitem "Any Tag" action ( nRFilterType := 1, RTagContext() ) checked
      else
         menuitem "Any Tag" action ( nRFilterType := 1, RTagContext() ) 
      endif
      if nRFilterType == 2 // all tags
         menuitem "All Tags" action ( nRFilterType := 2, RTagContext() ) checked
      else
         menuitem "All Tags" action ( nRFilterType := 2, RTagContext() ) 
      endif
   end menu
return nil

function exportreport
   local cHTML := ''
   if .not. iscontroldefined( 'reportgrid', 'report' )
      return nil
   endif
   do case
   case report.type.value == 1 // transaction summary
      cHTML := _grid2html( 'reportgrid', 'report', '', {'Vehicle Fuel Report', 'Transaction Summary Report from ' + dtoc( report.fromdate.value ) + ' to ' + dtoc( report.todate.value ), 'Date of Report : ' + dtoc( date() ) } )
   case report.type.value == 2 // transaction 
      cHTML := _grid2html( 'reportgrid', 'report', '', {'Vehicle Fuel Report', 'Transaction Report from ' + dtoc( report.fromdate.value ) + ' to ' + dtoc( report.todate.value ), 'Date of Report : ' + dtoc( date() ) } )
   case report.type.value == 3 // vehicle list
      cHTML := _grid2html( 'reportgrid', 'report', '', {'Vehicle Fuel Report', 'Vehicle List', 'Date of Report: ' + dtoc( date() ) } )
   case report.type.value == 4 // reminder list
      cHTML := _grid2html( 'reportgrid', 'report', '', {'Vehicle Fuel Report', 'Reminder List', 'Date of Report: ' + dtoc( date() ) } )
   endcase
   if file( cHTML )
      _Execute ( GetActiveWindow() , , cHTML,  , , 5 )   
   endif
return nil   
      
   
function exportcsvreport
   local cCSV := ''
   if .not. iscontroldefined( 'reportgrid', 'report' )
      return nil
   endif
   cCSV := grid2csv( 'report', 'reportgrid', .t. )
   if file( cCSV )
      _Execute ( GetActiveWindow() , , cCSV,  , , 5 )   
   endif
   

return nil

function printreport
   if .not. iscontroldefined( 'reportgrid', 'report' )
      return nil
   endif
// _gridprint(cGrid, cWindow, fontsize, orientation, aHeaders, fontname1, showwindow1, mheaders, summation, aArrayData, aArrayHeaders, aArrayJustify, aColumnWidths, nPaperSize, nPaperWidth, nPaperHeight, lVerticalLines, lHorizontalLines, nLeft, nTop, nRight, nBottom)   
   do case
   case report.type.value == 1 // transaction summary
      _gridprint( 'reportgrid', 'report', 10, 'P', {'Vehicle Fuel Report', 'Transaction Summary Report from ' + dtoc( report.fromdate.value ) + ' to ' + dtoc( report.todate.value ), 'Date of Report : ' + dtoc( date() ) }, 'Arial', .f. )
   case report.type.value == 2 // transaction 
      _gridprint( 'reportgrid', 'report', 10, 'P', {'Vehicle Fuel Report', 'Transaction Report from ' + dtoc( report.fromdate.value ) + ' to ' + dtoc( report.todate.value ), 'Date of Report : ' + dtoc( date() ) } , 'Arial', .f.)
   case report.type.value == 3 // vehicle list
      _gridprint( 'reportgrid', 'report', 10, 'P', {'Vehicle Fuel Report', 'Vehicle List', 'Date of Report: ' + dtoc( date() )}, 'Arial', .f. )
   case report.type.value == 4 // reminder list
      _gridprint( 'reportgrid', 'report', 10, 'P', {'Vehicle Fuel Report', 'Reminder List', 'Date of Report: ' + dtoc( date() ) }, 'Arial', .f. )
   endcase
return nil