#include <hmg.ch>

function tagmanager
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   define window tag at 0, 0 width 500 height 400 icon 'icon' title 'Tag Manager' modal nosize 
      define label taggrouplabel
         row 10
         col 10
         width 100
         value 'Tag Group :'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label
      define textbox taggroup
         row 10
         col 110
         width 330
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end textbox
      define button newtagmaster
         row 10
         col 445
         width 20
         height 20
         picture 'newitem'      
         tooltip 'Add a New Tag Group'         
         action addtagmaster()
      end button   
      define button deltagmaster
         row 10
         col 470
         width 20
         height 20
         picture 'delitem'      
         tooltip 'Remove a Tag Group. First remove all the tags under a group before removing it'         
         action deltaggroup()
      end button   
      define listbox taggroups
         row 35
         col 10
         width 480
         height 150
         ondblclick taggrouprename()
         onchange tagtagmasterchanged()
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end listbox   
      define label taglabel
         row 190
         col 10
         width 100
         value 'Tags'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label   
      define textbox tag
         row 190
         col 110
         width 330
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end textbox
      define button newtag
         row 190
         col 445
         width 20
         height 20
         picture 'newitem'         
         tooltip 'Add a New Tag'
         action addnewtag()
      end button   
      define button deletetag
         row 190
         col 470
         width 20
         height 20
         picture 'delitem'         
         tooltip 'Remove a Tag from the Tag List'
         action deltag()
      end button   
      define listbox tags
         row 215
         col 10
         width 480
         height 150
         ondblclick tagrename()
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end listbox   
      on key ESCAPE action tag.release
      define control context menu taggroups
         menuitem "Edit" action taggrouprename() image 'edit1' tooltip 'Edit this Tag Group'
         menuitem "Delete" action deltaggroup() image 'delete1' tooltip 'Delete this Tag Group. Make sure all the tags under this group were deleted already.'
      end menu
      define control context menu tags
         menuitem "Edit" action tagrename() image 'edit1' tooltip 'Edit this Tag'
         menuitem "Delete" action deltag() image 'delete1' tooltip 'Delete this Tag'
      end menu
   end window
   
   aTable := sql( oDB, 'select name from tagmaster order by name', @cErr )
   if hmg_len( cErr ) == 0
      for i := 1 to hmg_len( aTable )
         tag.taggroups.additem( aTable[ i, 1 ] )
      next i
      if hmg_len( aTable ) > 0
         tag.taggroups.value := 1 
      endif
   endif
   tag.center
   tag.activate
return nil

function tagtagmasterchanged
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local nLineNo := tag.taggroups.value
   local cTagGroup := ''   
   tag.tags.deleteallitems
   if nLineNo > 0
      cTagGroup := tag.taggroups.item( nLineNo )
      aTable := sql( oDB, 'select t.tagname from tags t, tagmaster tm where t.catid = tm.catid and tm.name = ' + c2sql( cTagGroup ) + ' order by t.tagname', @cErr )
      if hmg_len( cErr ) == 0
         for i := 1 to hmg_len( aTable )
            tag.tags.additem( aTable[ i, 1 ] )
         next i
         if hmg_len( aTable ) > 0
            tag.tags.value := 1 
         endif
      endif
   endif      
return nil

function addnewtag
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local nLineNo := tag.taggroups.value
   local cTagGroup := ''
   local cTag := tag.tag.value
   if nLineNo == 0
      msgstop( 'Select a Tag Group to add this tag to' )
      return nil
   endif
   if hmg_len( cTag ) == 0 
      msgstop( 'Tag name can not be empty!' )
      return nil
   endif
   cTagGroup := tag.taggroups.item( nLineNo )
   lOk := miscsql( oDB, 'insert into tags ( tagname, catid ) values ( ' + c2sql( cTag ) + ', ( select catid from tagmaster where name = ' + c2sql( cTagGroup ) + ' ) )', @cErr )
   if hmg_len( cErr ) == 0
      if lOk
         tag.tag.value := ''
         update_statistics()
         tagtagmasterchanged()
      else
         msgstop( 'Database Error!' )      
      endif
   else
      msgstop( cErr )   
   endif   
return nil


function addtagmaster
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local cTagGroup := tag.taggroup.value
   if hmg_len( cTagGroup ) == 0 
      msgstop( 'Tag Group name can not be empty!' )
      return nil
   endif
   lOk := miscsql( oDB, 'insert into tagmaster ( name ) values ( ' + c2sql( cTagGroup ) + ' )', @cErr )
   if hmg_len( cErr ) == 0
      if lOk
         tag.taggroup.value := ''
         update_statistics()
         tag.taggroups.deleteallitems
         aTable := sql( oDB, 'select name from tagmaster order by name', @cErr )
         if hmg_len( cErr ) == 0
            for i := 1 to hmg_len( aTable )
               tag.taggroups.additem( aTable[ i, 1 ] )
            next i
            if hmg_len( aTable ) > 0
               tag.taggroups.value := 1 
            endif
         endif
      else
         msgstop( 'Database Error!' )      
      endif
   else
      msgstop( cErr )   
   endif   
return nil


function deltaggroup
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local nLineNo := tag.taggroups.value
   local cTagGroup := ''
   if nLineNo == 0
      msgstop( 'Select a Tag Group to Delete' )
      return nil
   endif
   cTagGroup := tag.taggroups.item( nLineNo )
   aTable := sql( oDB, 'select t.tagname from tags t, tagmaster tm where t.catid = tm.catid and tm.name = ' + c2sql( cTagGroup ) + ' order by t.tagname', @cErr )
   if hmg_len( cErr ) == 0
      if hmg_len( aTable ) > 0
         msgstop( 'There are ' + alltrim( str( hmg_len( aTable ) ) ) + ' tags attached to this group. First delete those tags!' ) 
         return nil
      else
         if msgyesno( 'Are you sure to delete this tag group?')
            lOk := miscsql( oDB, 'delete from tagmaster where name = ' + c2sql( cTagGroup ), @cErr )
            if hmg_len( cErr ) == 0
               if .not. lOk
                  msgstop( 'Database Error!' )
                  return nil
               else
                  update_statistics()
                  tag.taggroups.deleteallitems
                  aTable := sql( oDB, 'select name from tagmaster order by name', @cErr )
                  if hmg_len( cErr ) == 0
                     for i := 1 to hmg_len( aTable )
                        tag.taggroups.additem( aTable[ i, 1 ] )
                     next i
                     if hmg_len( aTable ) > 0
                        tag.taggroups.value := 1 
                     endif
                  endif
               endif   
            else
               msgstop( cErr )         
            endif
         endif
      endif
   else
      msgstop( cErr )   
   endif      
return nil

function deltag
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local nLineNo := tag.taggroups.value
   local cTagGroup := ''
   local nTagLineNo := tag.tags.value
   local cTag := ''
   local lFound := .f.
   if nLineNo == 0
      msgstop( 'Select a Tag Group that belong to the tag to be deleted!' )
      return nil
   endif
   if nTagLineNo == 0
      msgstop( 'Select a Tag Delete' )
      return nil
   endif
   cTagGroup := tag.taggroups.item( nLineNo )
   cTag := tag.tags.item( nTagLineNo )
   aTable := sql( oDB, 'select * from generaltags where tagid = ( select tagid from tags where tagname = ' + c2sql( cTag ) + ' and catid = ( select catid from tagmaster where name = ' + c2sql( cTagGroup ) + ') )', @cErr )
   if hmg_len( cErr ) > 0
      msgstop( cErr )
      return nil
   endif
   if hmg_len( aTable ) > 0
      lFound := .t.
   endif
   aTable := sql( oDB, 'select * from reminder where tagid = ( select tagid from tags where tagname = ' + c2sql( cTag ) + ' and catid = ( select catid from tagmaster where name = ' + c2sql( cTagGroup ) + ') )', @cErr )
   if hmg_len( cErr ) > 0
      msgstop( cErr )
      return nil
   endif
   if hmg_len( aTable ) > 0
      lFound := .t.
   endif
   aTable := sql( oDB, 'select * from txntags where tagid = ( select tagid from tags where tagname = ' + c2sql( cTag ) + ' and catid = ( select catid from tagmaster where name = ' + c2sql( cTagGroup ) + ') )', @cErr )
   if hmg_len( cErr ) > 0
      msgstop( cErr )
      return nil
   endif
   if hmg_len( aTable ) > 0
      lFound := .t.
   endif
   if lFound
      if msgyesno( 'There are vehicles/transactions/reminders tagged with this tag. Do you want to remove this tag?', 'Tag Deletion' )
         lOk := miscsql( oDB, 'delete from reminder where tagid = ( select tagid from tags where tagname = ' + c2sql( cTag ) + ' and catid = ( select catid from tagmaster where name = ' + c2sql( cTagGroup ) + ') )', @cErr )
         if hmg_len( cErr ) > 0
            msgstop( cErr )
            return nil
         endif
         if .not. lOk
            msgstop( 'Database Error!' )
            return nil
         endif
         lOk := miscsql( oDB, 'delete from txntags where tagid = ( select tagid from tags where tagname = ' + c2sql( cTag ) + ' and catid = ( select catid from tagmaster where name = ' + c2sql( cTagGroup ) + ') )', @cErr )
         if hmg_len( cErr ) > 0
            msgstop( cErr )
            return nil
         endif
         if .not. lOk
            msgstop( 'Database Error!' )
            return nil
         endif
         lOk := miscsql( oDB, 'delete from generaltags where tagid = ( select tagid from tags where tagname = ' + c2sql( cTag ) + ' and catid = ( select catid from tagmaster where name = ' + c2sql( cTagGroup ) + ') )', @cErr )
         if hmg_len( cErr ) > 0
            msgstop( cErr )
            return nil
         endif
         if .not. lOk
            msgstop( 'Database Error!' )
            return nil
         endif
      else
         return nil      
      endif 
   endif      
   lOk := miscsql( oDB, 'delete from tags where tagname = ' + c2sql( cTag ) + ' and catid = ( select catid from tagmaster where name = ' + c2sql( cTaggroup ) + ')', @cErr )
   if hmg_len( cErr ) > 0
      msgstop( cErr )
      return nil
   endif
   if .not. lOk
      msgstop( 'Database Error!' )
      return nil
   endif
   update_statistics()
   tagtagmasterchanged()
return nil


function taggrouprename
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local nLineNo := tag.taggroups.value
   local cTagGroup := ''
   local cNewTagGroup := ''
   if nLineNo == 0
      msgstop( 'Select a Tag Group to Delete' )
      return nil
   endif
   cTagGroup := tag.taggroups.item( nLineNo )
   cNewTagGroup := alltrim( inputbox( 'Tag Group', 'Edit Tag Group', cTagGroup ) )
   if hmg_len( cNewTagGroup ) == 0
      return nil
   endif
   if cTagGroup == cNewTagGroup
      return nil
   endif
   if msgyesno( 'Are you sure to modify the tag group ' + cTagGroup + ' as ' + cNewTagGroup + '?' )
      lOk := miscsql( oDB, 'update tagmaster set name = ' + c2sql( cNewTagGroup ) + ' where name = ' + c2sql( cTagGroup ), @cErr )
      if hmg_len( cErr ) == 0
         if .not. lOk
            msgstop( 'Database Error!' )
            return nil
         endif
      else
         msgstop( cErr )
         return nil
      endif
      tag.taggroups.deleteallitems
      aTable := sql( oDB, 'select name from tagmaster order by name', @cErr )
      if hmg_len( cErr ) == 0
         for i := 1 to hmg_len( aTable )
            tag.taggroups.additem( aTable[ i, 1 ] )
         next i
         if hmg_len( aTable ) > 0
            tag.taggroups.value := 1 
         endif
      endif
   endif      
return nil

function tagrename
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local nLineNo := tag.taggroups.value
   local cTagGroup := ''
   local nTagLineNo := tag.tags.value
   local cTag := ''
   local lFound := .f.
   local cNewTag := ''
   if nLineNo == 0
      msgstop( 'Select a Tag Group that belong to the tag to be edited!' )
      return nil
   endif
   if nTagLineNo == 0
      msgstop( 'Select a Tag edit' )
      return nil
   endif
   cTagGroup := tag.taggroups.item( nLineNo )
   cTag := tag.tags.item( nTagLineNo )
   cNewTag := alltrim( inputbox( 'Tag', 'Edit Tag', cTag ) )
   if hmg_len( cNewTag ) == 0
      return nil
   endif
   if cTag == cNewTag
      return nil
   endif
   if msgyesno( 'Are you sure to modify the tag ' + cTag + ' as ' + cNewTag + '?' )
      lOk := miscsql( oDB, 'update tags set tagname = ' + c2sql( cNewTag ) + ' where tagname = ' + c2sql( cTag ) + ' and catid = ( select catid from tagmaster where name = ' + c2sql( cTagGroup ) + ')', @cErr )
      if hmg_len( cErr ) == 0
         if .not. lOk
            msgstop( 'Database Error!' )
            return nil
         endif
      else
         msgstop( cErr )
      endif
      tagtagmasterchanged()      
   endif      
return nil