#include <hmg.ch>

function vehmast
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   private nCurrentVehicleID := 0
   private cSort := 'Tag'
   && private lCheck := .t.
   define window vehicles at 0, 0 width 700 height 530 icon 'icon' title 'Vehicle Master' modal nosize // nosysmenu
      define toolbar toolbar1 imagewidth 24 imageheight 24 flat .t. strictwidth .t.
         button addvehicle   picture 'car'  action newveh() tooltip 'Add a new Vehicle' 
         button delvehicle   picture 'delete1'  action delveh() tooltip 'Delete the current vehicle in the vehicle list' 
         button tagmanager   picture 'tag'  action ( tagmanager(), vmvehiclechanged() ) tooltip 'Tag Manager' 
         button exit  picture 'exit' action vehicles.release() tooltip 'Close this window'
      end toolbar   
      define grid vehiclelist
         row 40
         col 10
         width 220
         headers { 'Sl.No.', 'Registration No.' }
         justify { 1, 0 }
         widths { 60, 130 }
         onchange vmvehiclechanged()
         ondblclick modveh()
         height 455
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end grid
      define label regnolabel
         row 40
         col 240
         width 120
         value 'Registration No.'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label
      define label regno
         row 40
         col 360
         width 330
//         uppercase .t.
         fontname cFontName
         fontsize nFontSize + 2
         fontbold .t.
         fontcolor { 0, 0, 255 }
      end label
      define label availabletaglabel
         row 70
         col 240
         width 450
         value 'Tags on this vehicle (Press SPACE to Check/Uncheck a Tag)'      
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label
      define grid taggrid
         row 95
         col 240
         height 210
         width 450
         headers { 'Tag', 'Group' }
         widths { 210, 210 }
         onheadclick { { || vmsortchange(1) }, { || vmsortchange(2) } }
         tooltip 'Press SPACE to Check/Uncheck'
         oncheckboxclicked vmtagchecked()
         justify { 0, 0 }
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
         onlostfocus vmtagchecked() // because of checkbox click bug
      end grid
      define label reminderdatelabel
         row 315
         col 390
         width 120
         value 'Reminder Date'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label   
      define textbox date
         row 315
         col 510
         width 120
         value date()
         date .t.
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end textbox
      define button adddate
         row 315
         col 640
         width 20
         height 20
         picture 'newitem'
         tooltip 'Add a Reminder'
         action vmaddreminder()
      end button   
      define button deldate
         row 315
         col 670
         width 20
         height 20
         picture 'delitem'
         tooltip 'Remove a Reminder'
         action vmdelreminder()
      end button   
      define grid reminders
         row 340
         col 240
         width 450
         headers { 'Reminder Tag', 'Group', 'Date' }
         widths { 150, 150 , 120 }
         ondblclick updatereminder()
         justify { 0, 0, 0 }         
         height 155
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end grid
      on key ESCAPE action vehicles.release
      define control context menu vehiclelist
         menuitem "Edit" action modveh() image 'edit1' tooltip 'Edit the vehicle registration number'
         menuitem "Delete" action delveh() image 'delete1' tooltip 'Delete this vehicle'
      end menu
      define control context menu reminders
         menuitem "Edit" action updatereminder() image 'edit1' tooltip 'Edit this reminder'
         menuitem "Delete" action vmdelreminder() image 'delete1' tooltip 'Delete this reminder'
      end menu
   end window
   vehicles.taggrid.CheckBoxEnabled := .t.
   aFont := ARRAY FONT cFontName SIZE nFontSize BOLD
   vehicles.taggrid.ColumnDYNAMICFONT  (1) := {|| IF ( vehicles.taggrid.checkboxitem( This.CellRowIndex ), aFont, NIL) }
   vehicles.taggrid.ColumnDYNAMICFONT  (2) := {|| IF ( vehicles.taggrid.checkboxitem( This.CellRowIndex ), aFont, NIL) }
   
   vehicles.reminders.ColumnDYNAMICFONT  (1) := {|| aFont }
   vehicles.reminders.ColumnDYNAMICFONT  (2) := {|| aFont }
   vehicles.reminders.ColumnDYNAMICFONT  (3) := {|| aFont }
   
   aTable := sql( oDB, 'select v.regno from vehicles v order by v.regno', @cErr )
   if hmg_len( cErr ) == 0
      for i := 1  to hmg_len( aTable )
         vehicles.vehiclelist.additem( { str( i ), aTable[ i, 1 ] } )
      next i
      if hmg_len( aTable ) > 0
         vehicles.vehiclelist.value := 1 
      endif
   endif      
   vehicles.center
   vehicles.activate
return nil

function newveh
   define window newvehicle at 0, 0 width 400 height 120 icon 'icon' title 'New Vehicle' modal nosize
      define label regnolabel
         row 10
         col 10
         width 150
         value 'Registration No.'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label
      define textbox regno
         row 10
         col 160
         width 280
         uppercase .t.
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end textbox
      define button save
         row 40
         col 110
         width 80
         caption 'Save'
         action savenewveh()         
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end button   
      define button cancel
         row 40
         col 210
         width 80
         caption 'Cancel'
         action newvehicle.release
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end button   
      on key ESCAPE action newvehicle.release
   end window
   newvehicle.center
   newvehicle.activate
return nil

function savenewveh
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local cRegNo := alltrim( newvehicle.regno.value )
   if hmg_len( cRegNo ) == 0
      msgstop( 'Registration Number can not be empty!' )
      return nil
   endif
   lOk := miscsql( oDB, 'insert into vehicles ( regno ) values ( ' + c2sql( cRegNo ) + ')', @cErr )   
   if hmg_len( cErr ) == 0
      if .not. lOk
         msgstop( 'Database Error!' )
         return nil
      endif
      update_statistics()
      newvehicle.release
      vehicles.vehiclelist.deleteallitems
      aTable := sql( oDB, 'select v.regno from vehicles v order by v.regno', @cErr )
      if hmg_len( cErr ) == 0
         for i := 1  to hmg_len( aTable )
            vehicles.vehiclelist.additem( { str( i ), aTable[ i, 1 ] } )
         next i
         if hmg_len( aTable ) > 0
            vehicles.vehiclelist.value := 1 
         endif
      endif      
   else
      msgstop( cErr )
   endif
return nil

function modveh
   local cRegNo := vehicles.regno.value
   define window newvehicle at 0, 0 width 400 height 120 icon 'icon'  title 'Modify Vehicle Details' modal nosize
      define label regnolabel
         row 10
         col 10
         width 150
         value 'Registration No.'
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end label
      define textbox regno
         row 10
         col 160
         width 280
         uppercase .t.
         value vehicles.regno.value
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end textbox
      define button save
         row 40
         col 110
         width 80
         caption 'Modify'
         action modifyveh()         
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end button   
      define button cancel
         row 40
         col 210
         width 80
         caption 'Cancel'
         action newvehicle.release
         fontname cFontName
         fontsize nFontSize
         fontbold lFontBold
      end button   
      on key ESCAPE action newvehicle.release
   end window
   newvehicle.center
   newvehicle.activate
return nil

function modifyveh
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local cNewRegNo := alltrim( newvehicle.regno.value )
   local cRegNo := vehicles.regno.value
   if hmg_len( cNewRegNo ) == 0
      msgstop( 'Registration Number can not be empty!' )
      return nil
   endif
   if cNewRegNo == cRegNo
      newvehicle.release
      return nil
   endif
   if .not. msgyesno( 'Are you sure to modify vehicle registration number ' + cRegNo + ' as ' + cNewRegNo + '?'  )
      return nil
   endif
   lOk := miscsql( oDB, 'update vehicles set regno = ' + c2sql( cNewRegNo ) + ' where regno = ' + c2sql( cRegNo ), @cErr )   
   if hmg_len( cErr ) == 0
      if .not. lOk
         msgstop( 'Database Error!' )
         return nil
      endif
      update_statistics()
      newvehicle.release
      vehicles.vehiclelist.deleteallitems
      aTable := sql( oDB, 'select v.regno from vehicles v order by v.regno', @cErr )
      if hmg_len( cErr ) == 0
         for i := 1  to hmg_len( aTable )
            vehicles.vehiclelist.additem( { str( i ), aTable[ i, 1 ] } )
         next i
         if hmg_len( aTable ) > 0
            vehicles.vehiclelist.value := 1 
         endif
      endif      
   else
      msgstop( cErr )
   endif
return nil

function delveh
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local cRegNo := vehicles.regno.value
   local lFound := .f.
   if hmg_len( cRegNo ) == 0
      return nil
   endif
   aTable := sql( oDB, 'select * from txn where vehicleid = ( select id from vehicles where regno = ' + c2sql( cRegNo ) + ') ', @cErr)
   if hmg_len( cErr ) == 0
      if hmg_len( aTable ) > 0
         if .not. msgyesno( 'There are transactions entered for this vehicle! Are sure sure to delete this vehicle along with transactions/tags/reminders?' )
            return nil
         endif
      endif
   else
      msgstop( cErr )   
   endif
   if .not. msgyesno( 'Are you sure to remove this vehicle from database? You can not undo!' )
      return nil
   endif
   lOk := miscsql( oDB, 'delete from reminder where vehicleid = ( select id from vehicles where regno = ' + c2sql( cRegNo ) + ') ', @cErr)
   if hmg_len( cErr ) == 0
      if .not. lOk
         msgstop( 'Database Error!' )
         return nil
      endif
   else
      msgstop( cErr )
      return nil
   endif
   lOk := miscsql( oDB, 'delete from generaltags where vehicleid = ( select id from vehicles where regno = ' + c2sql( cRegNo ) + ') ', @cErr)
   if hmg_len( cErr ) == 0
      if .not. lOk
         msgstop( 'Database Error!' )
         return nil
      endif
   else
      msgstop( cErr )
      return nil
   endif
   lOk := miscsql( oDB, 'delete from txntags where txnid in ( select txnid from txn where vehicleid = ( select id from vehicles where regno = ' + c2sql( cRegNo ) + ') ) ', @cErr)
   if hmg_len( cErr ) == 0
      if .not. lOk
         msgstop( 'Database Error!' )
         return nil
      endif
   else
      msgstop( cErr )
      return nil
   endif
   lOk := miscsql( oDB, 'delete from txn where vehicleid = ( select id from vehicles where regno = ' + c2sql( cRegNo ) + ') ', @cErr)
   if hmg_len( cErr ) == 0
      if .not. lOk
         msgstop( 'Database Error!' )
         return nil
      endif
   else
      msgstop( cErr )
      return nil
   endif
   lOk := miscsql( oDB, 'delete from vehicles where regno = ' + c2sql( cRegNo ), @cErr)
   if hmg_len( cErr ) == 0
      if .not. lOk
         msgstop( 'Database Error!' )
         return nil
      endif
   else
      msgstop( cErr )
      return nil
   endif
   update_statistics()
   vehicles.vehiclelist.deleteallitems
   aTable := sql( oDB, 'select v.regno from vehicles v order by v.regno', @cErr )
   if hmg_len( cErr ) == 0
      for i := 1  to hmg_len( aTable )
         vehicles.vehiclelist.additem( { str( i ), aTable[ i, 1 ] } )
      next i
      if hmg_len( aTable ) > 0
         vehicles.vehiclelist.value := 1 
      endif
   endif      
return nil

function vmtagchecked
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local nLineNo := vehicles.taggrid.value
   local cTagGroup := ''
   local aLineData := {}
   local cTag := ''
   local nTagLine := 1
   && if lCheck
      && // for the space key bug!
      && return nil
   && endif
   if nCurrentVehicleID == 0
      msgstop( 'You have to select a vehicle to apply the tag!' )
      return nil
   endif
   lOk := miscsql( oDB, 'delete from generaltags where vehicleid = ' + c2sql( nCurrentVehicleID ), @cErr )
   if hmg_len( cErr ) > 0
      msgstop( 'Database Error! - ' + cErr )
      return nil
   endif
   if .not. lOk
      msgstop( 'Database Error! - ' + cErr )
      return nil
   endif
   for i := 1 to vehicles.taggrid.itemcount
      if vehicles.taggrid.checkboxitem( i )
         aLineData := vehicles.taggrid.item( i )
         cTag := aLineData[ 1 ]
         cTagGroup := aLineData[ 2 ]
         lOk := miscsql( oDB, 'insert into generaltags ( tagid, vehicleid ) values ( ' + ;
                         '( select tagid from tags where tagname = ' + c2sql( cTag ) + ' and catid = ( select catid from tagmaster where name = ' + c2sql( cTagGroup ) + ' ) )' + ', ' + ;
                         c2sql( nCurrentVehicleID ) + ' )', @cErr )
         if hmg_len( cErr ) > 0
            msgstop( 'Database Error! - ' + cErr )
            return nil
         endif
         if .not. lOk
            msgstop( 'Database Error!' )
            return nil
         endif
      endif
   next i
   update_statistics()
   vmvehiclechanged()
return nil   

function vmvehiclechanged
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local nLineNo := vehicles.vehiclelist.value
   local cRegNo := ''
   local aLineData := {}
   nCurrentVehicleID := 0
   stopcontroleventprocedure( 'taggrid', 'vehicles', .t. )
   vehicles.taggrid.deleteallitems
   vehicles.reminders.deleteallitems
   if nLineNo > 0
      aLineData := vehicles.vehiclelist.item( nLineNo )
      cRegNo := aLineData[ 2 ]
      aTable := sql( oDB, 'select id from vehicles where regno = ' + c2sql( cRegNo ), @cErr )
      if hmg_len( cErr ) == 0
         if hmg_len( aTable ) > 0
            nCurrentVehicleID := aTable[ 1, 1 ]
         endif
      endif
      vehicles.regno.value := cRegNo
      if nCurrentVehicleID > 0
         do case
         case cSort == 'Tag'
            aTable := sql( oDB, 'select t.tagname, tm.name, case when t.tagid in ( select tagid from generaltags where vehicleid = ' + c2sql( nCurrentVehicleID ) + ') then ' + c2sql( 'A' ) + ' else ' + c2sql( 'B' ) + ' end as available from tags t, tagmaster tm where t.catid = tm.catid order by available, t.tagname, tm.name', @cErr ) 
         case cSort == 'Group'   
            aTable := sql( oDB, 'select t.tagname, tm.name, case when t.tagid in ( select tagid from generaltags where vehicleid = ' + c2sql( nCurrentVehicleID ) + ') then ' + c2sql( 'A' ) + ' else ' + c2sql( 'B' ) + ' end as available from tags t, tagmaster tm where t.catid = tm.catid order by available, tm.name, t.tagname', @cErr ) 
         endcase   
         if hmg_len( cErr ) == 0
            for i := 1 to hmg_len( aTable )
              vehicles.taggrid.additem( { aTable[ i, 1 ], aTable[ i, 2 ] } )
              if aTable[ i, 3 ] == 'A'
                 vehicles.taggrid.checkboxitem( i ) := .t.
              endif
            next i
         else
            msgstop( cErr )   
         endif   
         if vehicles.taggrid.itemcount > 0
            vehicles.taggrid.value := 1 
         endif
         stopcontroleventprocedure( 'taggrid', 'vehicles', .f. )
         
         // reminders 
         aTable := sql( oDB, 'select tm.name, t.tagname, r.date from tagmaster tm, tags t, reminder r where r.tagid = t.tagid and t.catid = tm.catid and r.vehicleid = ' + c2sql( nCurrentVehicleID ) + ' order by r.date, tm.name, t.tagname', @cErr )      
         if hmg_len( cErr ) == 0
            if hmg_len( aTable ) > 0
               for i := 1 to hmg_len( aTable )
                  vehicles.reminders.additem( { aTable[ i, 1 ], aTable[ i, 2 ], dtoc( aTable[ i, 3 ] ) } )
               next i
               vehicles.reminders.value := 1
            endif
         endif
      endif
   endif      
return nil

function vmaddreminder
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local cTagGroup := ''
   local aLineData := {}
   local cTag := ''
   local nLineNo := vehicles.taggrid.value
   && if lCheck
      && // for the space key bug!
      && return nil
   && endif
   if nCurrentVehicleID == 0
      msgstop( 'You have to select a vehicle to apply the tag!' )
      return nil
   endif
   if nLineNo > 0
      aLineData := vehicles.taggrid.item( nLineNo )
      cTag := aLineData[ 1 ]
      cTagGroup := aLineData[ 2 ]
   else
      msgstop( 'You have to select a tag to remind!' )
      return nil
   endif
   if vehicles.date.value <= date()
      if .not. msgyesno( 'Reminder date is either today or already past! Do you still want to add this reminder?', 'Add a reminder' )
         return nil
      endif
   endif      
   // find whether there is a reminder already!
   aTable := sql( oDB, 'select date from reminder where vehicleid = ' + c2sql( nCurrentVehicleID ) + ' and tagid = ( select t.tagid from tags t where t.tagname = ' + c2sql( cTag ) + ' and t.catid = ( select tm.catid from tagmaster tm where tm.name = ' + c2sql( cTagGroup ) + ' ) )', @cErr )
   if hmg_len( cErr ) == 0
      if hmg_len( aTable ) > 0
         if .not. msgyesno( 'There is already a reminder on ' + dtoc( aTable[ 1, 1 ] ) + '. Do you want to update the existing reminder?', 'Add a reminder' )
            return nil
         endif
         lOk := miscsql( oDB, 'update reminder set date = ' + c2sql( vehicles.date.value ) + ' where vehicleid = ' + c2sql( nCurrentVehicleID ) + ' and tagid = ( select t.tagid from tags t where t.tagname = ' + c2sql( cTag ) + ' and t.catid = ( select tm.catid from tagmaster tm where tm.name = ' + c2sql( cTagGroup ) + ' ) )', @cErr )
         if hmg_len( cErr ) > 0
            msgstop( 'Database Error - ' + cErr )
            return nil
         endif
         if .not. lOk
            msgstop( 'Database Error - ' + cErr )
            return nil
         endif
      else
         // new reminder
         lOk := miscsql( oDB, 'insert into reminder ( tagid, date, vehicleid ) values ( ' + ;
                         '( select t.tagid from tags t where t.tagname = ' + c2sql( cTag ) + ' and t.catid = ( select tm.catid from tagmaster tm where tm.name = ' + c2sql( cTagGroup ) + ' ) ), ' + ;
                         c2sql( vehicles.date.value ) + ', ' + ;
                         c2sql( nCurrentVehicleID ) + ' )', @cErr )
         if hmg_len( cErr ) > 0
            msgstop( 'Database Error - ' + cErr )
            return nil
         endif
         if .not. lOk
            msgstop( 'Database Error - ' + cErr )
            return nil
         endif
      endif
   else
      msgstop( 'Database Error! - ' + cErr )
   endif
   update_statistics()
   vehicles.reminders.deleteallitems
   aTable := sql( oDB, 'select tm.name, t.tagname, r.date from tagmaster tm, tags t, reminder r where r.tagid = t.tagid and t.catid = tm.catid and r.vehicleid = ' + c2sql( nCurrentVehicleID ) + ' order by r.date, t.tagname, tm.name', @cErr )      
   if hmg_len( cErr ) == 0
      if hmg_len( aTable ) > 0
         for i := 1 to hmg_len( aTable )
            vehicles.reminders.additem( { aTable[ i, 2 ], aTable[ i, 1 ], dtoc( aTable[ i, 3 ] ) } )
         next i
         vehicles.reminders.value := 1
      endif
   endif
return nil

function tagcheckboxbug
//   lCheck := .t.
//   vehicles.tags.deleteallitems
//   vehicles.tags.additem( { '' } )
//   vehicles.tags.value := 1
//   vehicles.tags.setfocus()
//   _PushKey(VK_SPACE)
//   vehicles.tags.deleteallitems()
//   lCheck := .f.
return nil

function updatereminder
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local nLineNo := vehicles.reminders.value
   local cTagGroup := ''
   local aLineData := {}
   local cTag := ''
   local aData := {}
   local dOldDate := date()
   if nCurrentVehicleID == 0
      msgstop( 'You have to select a vehicle to apply the tag!' )
      return nil
   endif
   if nLineNo > 0
      aLineData := vehicles.reminders.item( nLineNo )
      cTagGroup := aLineData[ 1 ]
      cTag := aLineData[ 2 ]
      dOldDate := ctod( aLineData[ 3 ] )
   else
      msgstop( 'You have to select a tag group to apply the tag!' )
      return nil
   endif
   aData := InputWindow( 'Update reminder date', {'New Date :'}, { dOldDate }, { Nil } )
   if hmg_len( aData ) == 0
      return nil
   endif
   if aData[ 1 ] == nil
      return nil
   endif
   if aData[ 1 ] <= date()
      if .not. msgyesno( 'Reminder date is either today or already past! Do you still want to update this reminder?', 'Update a reminder' )
         return nil
      endif
   endif      
   lOk := miscsql( oDB, 'update reminder set date = ' + c2sql( aData[ 1 ] ) + ' where vehicleid = ' + c2sql( nCurrentVehicleID ) + ' and tagid = ( select t.tagid from tags t where t.tagname = ' + c2sql( cTag ) + ' and t.catid = ( select tm.catid from tagmaster tm where tm.name = ' + c2sql( cTagGroup ) + ' ) )', @cErr )
   if hmg_len( cErr ) > 0
      msgstop( 'Database Error - ' + cErr )
      return nil
   endif
   if .not. lOk
      msgstop( 'Database Error - ' + cErr )
      return nil
   endif
   update_statistics()
   vehicles.reminders.deleteallitems
   aTable := sql( oDB, 'select tm.name, t.tagname, r.date from tagmaster tm, tags t, reminder r where r.tagid = t.tagid and t.catid = tm.catid and r.vehicleid = ' + c2sql( nCurrentVehicleID ) + ' order by r.date, tm.name, t.tagname', @cErr )      
   if hmg_len( cErr ) == 0
      if hmg_len( aTable ) > 0
         for i := 1 to hmg_len( aTable )
            vehicles.reminders.additem( { aTable[ i, 1 ], aTable[ i, 2 ], dtoc( aTable[ i, 3 ] ) } )
         next i
         vehicles.reminders.value := 1
      endif
   endif
return nil

function vmdelreminder
   local aTable := {}, i := 0, lOk := .f., cErr := ''
   local nLineNo := vehicles.reminders.value
   local cTagGroup := ''
   local aLineData := {}
   local cTag := ''
   local aData := {}
   local dOldDate := date()
   if nCurrentVehicleID == 0
      msgstop( 'You have to select a vehicle to apply the tag!' )
      return nil
   endif
   if nLineNo > 0
      aLineData := vehicles.reminders.item( nLineNo )
      cTagGroup := aLineData[ 1 ]
      cTag := aLineData[ 2 ]
   else
      msgstop( 'You have to select a tag group to delete the tag!' )
      return nil
   endif
   if .not. msgyesno( 'Are you sure to remove this reminder?', 'Remove a reminder' )
      return nil
   endif      
   lOk := miscsql( oDB, 'delete from reminder where vehicleid = ' + c2sql( nCurrentVehicleID ) + ' and tagid = ( select t.tagid from tags t where t.tagname = ' + c2sql( cTag ) + ' and t.catid = ( select tm.catid from tagmaster tm where tm.name = ' + c2sql( cTagGroup ) + ' ) )', @cErr )
   if hmg_len( cErr ) > 0
      msgstop( 'Database Error - ' + cErr )
      return nil
   endif
   if .not. lOk
      msgstop( 'Database Error - ' + cErr )
      return nil
   endif
   update_statistics()
   vehicles.reminders.deleteallitems
   aTable := sql( oDB, 'select tm.name, t.tagname, r.date from tagmaster tm, tags t, reminder r where r.tagid = t.tagid and t.catid = tm.catid and r.vehicleid = ' + c2sql( nCurrentVehicleID ) + ' order by r.date, tm.name, t.tagname', @cErr )      
   if hmg_len( cErr ) == 0
      if hmg_len( aTable ) > 0
         for i := 1 to hmg_len( aTable )
            vehicles.reminders.additem( { aTable[ i, 1 ], aTable[ i, 2 ], dtoc( aTable[ i, 3 ] ) } )
         next i
         vehicles.reminders.value := 1
      endif
   endif
return nil

function vmsortchange( nHead )
   if nHead == 1
      if cSort == 'Group'
         cSort := 'Tag'
      endif
   else
      if cSort == 'Tag'
         cSort := 'Group'
      endif
   endif   
   vmvehiclechanged()
return nil
